/*==============================================================*/
/* Table: O2P_T_ACSESSION                                       */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_ACSESSION (
   ID                   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   PROJECT4ACSESSION_CODE ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   OSCHEMA4ACSESSION_NAME ORA2PG_PROJECT.O2P_D_NAME           NULL,
   RESCODE4ACSESSION_CODE ORA2PG_PROJECT.O2P_D_CODE32         NULL,
   STEP4ACSESSION_ID    ORA2PG_PROJECT.O2P_D_ID             NULL,
   START_DATE           ORA2PG_PROJECT.O2P_D_DATETIME       NOT NULL,
   RESULT               ORA2PG_PROJECT.O2P_D_TEXT           NULL,
   REPORT_ONLY          ORA2PG_PROJECT.O2P_D_NY             NOT NULL,
   DATA_ONLY            ORA2PG_PROJECT.O2P_D_NY             NOT NULL,
   CHECK_RESTRICTIONS   ORA2PG_PROJECT.O2P_D_NY             NOT NULL,
   OBJECTS4RUN_CODE     ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL DEFAULT 'ALL',
   UPDATE_ORACLE_DDL    ORA2PG_PROJECT.O2P_D_YN             NOT NULL,
   ERRTEXT              ORA2PG_PROJECT.O2P_D_TEXT           NULL
)
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_ACSESSION IS '  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION.ID IS 'ID ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION.PROJECT4ACSESSION_CODE IS ' ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION.OSCHEMA4ACSESSION_NAME IS '  Oracle';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION.RESCODE4ACSESSION_CODE IS '   ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION.STEP4ACSESSION_ID IS 'ID     ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION.START_DATE IS '  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION.RESULT IS '  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION.REPORT_ONLY IS '    ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION.DATA_ONLY IS '  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION.CHECK_RESTRICTIONS IS '  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION.OBJECTS4RUN_CODE IS ',   : ALL -   ; CR -    " " (Conversion Required)';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION.UPDATE_ORACLE_DDL IS ' ddl-  Oracle';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION.ERRTEXT IS '    ';

ALTER TABLE ORA2PG_PROJECT.O2P_T_ACSESSION
   ADD CONSTRAINT O2P_T_ACSESSION_PK PRIMARY KEY (ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_PROJECT4ACSESSION_FK                            */
/*==============================================================*/
CREATE  INDEX O2P_T_PROJECT4ACSESSION_FK ON ORA2PG_PROJECT.O2P_T_ACSESSION (
PROJECT4ACSESSION_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_OSCHEMA4ACSESSION_FK                            */
/*==============================================================*/
CREATE  INDEX O2P_T_OSCHEMA4ACSESSION_FK ON ORA2PG_PROJECT.O2P_T_ACSESSION (
OSCHEMA4ACSESSION_NAME,
PROJECT4ACSESSION_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_RESCODE4ACSESSION_FK                            */
/*==============================================================*/
CREATE  INDEX O2P_T_RESCODE4ACSESSION_FK ON ORA2PG_PROJECT.O2P_T_ACSESSION (
RESCODE4ACSESSION_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_STEP4ACSESSION_FK                               */
/*==============================================================*/
CREATE  INDEX O2P_T_STEP4ACSESSION_FK ON ORA2PG_PROJECT.O2P_T_ACSESSION (
STEP4ACSESSION_ID
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_OBJECTS4RUN_FK                                  */
/*==============================================================*/
CREATE  INDEX O2P_T_OBJECTS4RUN_FK ON ORA2PG_PROJECT.O2P_T_ACSESSION (
OBJECTS4RUN_CODE
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_ACSESSION
   ADD CONSTRAINT O2P_T_OBJECTS4RUN_FK FOREIGN KEY (OBJECTS4RUN_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_OBJECTS4RUN (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_ACSESSION
   ADD CONSTRAINT O2P_T_OSCHEMA4ACSESSION_FK FOREIGN KEY (OSCHEMA4ACSESSION_NAME, PROJECT4ACSESSION_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_ORACLE_SCHEMA (NAME, PROJECT4OSCHEMA_CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_ACSESSION
   ADD CONSTRAINT O2P_T_PROJECT4ACSESSION_FK FOREIGN KEY (PROJECT4ACSESSION_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_PROJECT (CODE)
      ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_ACSESSION
   ADD CONSTRAINT O2P_T_RESCODE4ACSESSION_FK FOREIGN KEY (RESCODE4ACSESSION_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_ACSESSION_RESCODE (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_ACSESSION
   ADD CONSTRAINT O2P_T_STEP4ACSESSION_FK FOREIGN KEY (STEP4ACSESSION_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_STEP (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;
