/*==============================================================*/
/* Table: O2P_T_ACSESSION_OBJECT                                */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_ACSESSION_OBJECT (
   ID                   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   O4ACSO_ID            ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   ACSESSION4ACSO_ID    ORA2PG_PROJECT.O2P_D_ID             NOT NULL
)
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_ACSESSION_OBJECT IS ' Postgres     ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION_OBJECT.ID IS 'ID  Postgres    ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION_OBJECT.O4ACSO_ID IS 'ID  Postgres,   ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION_OBJECT.ACSESSION4ACSO_ID IS 'ID   ';

ALTER TABLE ORA2PG_PROJECT.O2P_T_ACSESSION_OBJECT
   ADD CONSTRAINT O2P_T_ACSESSION_OBJECT_PK PRIMARY KEY (ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_O4ACSO_FK                                       */
/*==============================================================*/
CREATE  INDEX O2P_T_O4ACSO_FK ON ORA2PG_PROJECT.O2P_T_ACSESSION_OBJECT (
O4ACSO_ID
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_ACSESSION4ACSO_FK                               */
/*==============================================================*/
CREATE  INDEX O2P_T_ACSESSION4ACSO_FK ON ORA2PG_PROJECT.O2P_T_ACSESSION_OBJECT (
ACSESSION4ACSO_ID
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_ACSESSION_OBJECT
   ADD CONSTRAINT O2P_T_ACSESSION4ACSO_FK FOREIGN KEY (ACSESSION4ACSO_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_ACSESSION (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_ACSESSION_OBJECT
   ADD CONSTRAINT O2P_T_O4ACSO_FK FOREIGN KEY (O4ACSO_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_OBJECT (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;


ALTER TABLE ORA2PG_PROJECT.O2P_T_FILE
   ADD CONSTRAINT O2P_T_ACSO4FILE_FK FOREIGN KEY (ACSO4FILE_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_ACSESSION_OBJECT (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;