/*==============================================================*/
/* Table: O2P_T_ACSESSION_OT                                    */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_ACSESSION_OT (
   ID                   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   ACSESSION4ACOT_ID    ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   OT_CODE              ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   RESCODE4ACOT_CODE    ORA2PG_PROJECT.O2P_D_CODE32         NULL
)
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_ACSESSION_OT IS ' ,   ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION_OT.ID IS 'id';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION_OT.ACSESSION4ACOT_ID IS 'ID ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION_OT.OT_CODE IS '   ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION_OT.RESCODE4ACOT_CODE IS '   ';

ALTER TABLE ORA2PG_PROJECT.O2P_T_ACSESSION_OT
   ADD CONSTRAINT O2P_T_ACSESSION_OT_PK PRIMARY KEY (ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_OT4ACSESSIONOT_FK                               */
/*==============================================================*/
CREATE  INDEX O2P_T_OT4ACSESSIONOT_FK ON ORA2PG_PROJECT.O2P_T_ACSESSION_OT (
OT_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_ACSESSION4ACOT_FK                               */
/*==============================================================*/
CREATE  INDEX O2P_T_ACSESSION4ACOT_FK ON ORA2PG_PROJECT.O2P_T_ACSESSION_OT (
ACSESSION4ACOT_ID
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_RESCODE4ACOT_FK                                 */
/*==============================================================*/
CREATE  INDEX O2P_T_RESCODE4ACOT_FK ON ORA2PG_PROJECT.O2P_T_ACSESSION_OT (
RESCODE4ACOT_CODE
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_ACSESSION_OT
   ADD CONSTRAINT O2P_T_ACSESSION4ACSOT_FK FOREIGN KEY (ACSESSION4ACOT_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_ACSESSION (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_ACSESSION_OT
   ADD CONSTRAINT O2P_T_OT4ACOT_FK FOREIGN KEY (OT_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_OBJECT_TYPE (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_ACSESSION_OT
   ADD CONSTRAINT O2P_T_RESCODE4ACOT_FK FOREIGN KEY (RESCODE4ACOT_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_ACSESSION_RESCODE (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_FILE
   ADD CONSTRAINT O2P_T_ACSESSIONOT4FILE_FK FOREIGN KEY (ACSESSIONOT4FILE_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_ACSESSION_OT (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;
