/*==============================================================*/
/* Table: O2P_T_ACSESSION_TASK                                  */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_ACSESSION_TASK (
   ACSESSION4TASK_ID    ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   CODE                 ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   RESCODE4TASK_CODE    ORA2PG_PROJECT.O2P_D_CODE32         NULL,
   ERROR_TEXT           ORA2PG_PROJECT.O2P_D_TEXT           NULL
);

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_ACSESSION_TASK IS ',     ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION_TASK.ACSESSION4TASK_ID IS 'ID  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION_TASK.CODE IS ' ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION_TASK.RESCODE4TASK_CODE IS '  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ACSESSION_TASK.ERROR_TEXT IS '   ';

ALTER TABLE ORA2PG_PROJECT.O2P_T_ACSESSION_TASK
   ADD CONSTRAINT O2P_T_ACSESSION_TASK_PK PRIMARY KEY (ACSESSION4TASK_ID, CODE)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_ACSESSION4TASK_FK                               */
/*==============================================================*/
CREATE  INDEX O2P_T_ACSESSION4TASK_FK ON ORA2PG_PROJECT.O2P_T_ACSESSION_TASK (
ACSESSION4TASK_ID
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_RESCODE4TASK_FK                                 */
/*==============================================================*/
CREATE  INDEX O2P_T_RESCODE4TASK_FK ON ORA2PG_PROJECT.O2P_T_ACSESSION_TASK (
RESCODE4TASK_CODE
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_ACSESSION_TASK
   ADD CONSTRAINT O2P_T_ACSESSION4TASK_FK FOREIGN KEY (ACSESSION4TASK_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_ACSESSION (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_ACSESSION_TASK
   ADD CONSTRAINT O2P_T_RESCODE4TASK_FK FOREIGN KEY (RESCODE4TASK_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_ACSESSION_RESCODE (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;
