/*==============================================================*/
/* Table: O2P_T_OBJECT_RESTRICTION                              */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION (
   ID                   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   ACSESSION4ORESTRICTION_ID ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   RTYPE4ORESTRICTION_CODE ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   PROJECT4ORESTRICTION_CODE ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   PO4ORESTRICTION_ID   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   ATTENTION_TO         ORA2PG_PROJECT.O2P_D_DESCRIPTION    NOT NULL,
   TODO                 ORA2PG_PROJECT.O2P_D_DESCRIPTION    NULL,
   NOTES                ORA2PG_PROJECT.O2P_D_NOTES          NULL
)
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION IS '     ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION.ID IS 'ID ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION.ACSESSION4ORESTRICTION_ID IS 'ID  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION.RTYPE4ORESTRICTION_CODE IS '  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION.PROJECT4ORESTRICTION_CODE IS ' ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION.PO4ORESTRICTION_ID IS 'ID  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION.ATTENTION_TO IS ' ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION.TODO IS '    ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION.NOTES IS '  ';

ALTER TABLE ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION
   ADD CONSTRAINT O2P_T_OBJECT_RESTRICTION_PK PRIMARY KEY (ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_RTYPE4ORESTRICTION_FK                           */
/*==============================================================*/
CREATE  INDEX O2P_T_RTYPE4ORESTRICTION_FK ON ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION (
RTYPE4ORESTRICTION_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_PO4ORESTRICTION_FK                              */
/*==============================================================*/
CREATE  INDEX O2P_T_PO4ORESTRICTION_FK ON ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION (
PO4ORESTRICTION_ID
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_PROJECT4ORESTRICTION_FK                         */
/*==============================================================*/
CREATE  INDEX O2P_T_PROJECT4ORESTRICTION_FK ON ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION (
PROJECT4ORESTRICTION_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_ACSESSION4ORESTRICTION_FK                       */
/*==============================================================*/
CREATE  INDEX O2P_T_ACSESSION4ORESTRICTION_FK ON ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION (
ACSESSION4ORESTRICTION_ID
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION
   ADD CONSTRAINT O2P_T_ACSESSION4ORESTRICTION_FK FOREIGN KEY (ACSESSION4ORESTRICTION_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_ACSESSION (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION
   ADD CONSTRAINT O2P_T_PO4ORESTRICTION_FK FOREIGN KEY (PO4ORESTRICTION_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_PROJECT_OBJECT (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION
   ADD CONSTRAINT O2P_T_PROJECT4ORESTRICTION_FK FOREIGN KEY (PROJECT4ORESTRICTION_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_PROJECT (CODE)
      ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_OBJECT_RESTRICTION
   ADD CONSTRAINT O2P_T_RTYPE4ORESTRICTION_FK FOREIGN KEY (RTYPE4ORESTRICTION_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_RESTRICTION_TYPE (CODE)
      ON DELETE CASCADE ON UPDATE CASCADE;
