﻿/*==============================================================*/
/* Table: O2P_T_ORACLE_CONNECTION                               */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_ORACLE_CONNECTION (
   ID                   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   ALIAS                ORA2PG_PROJECT.O2P_D_NAME           NOT NULL,
   HOST                 ORA2PG_PROJECT.O2P_D_NAME           NOT NULL,
   PORT                 ORA2PG_PROJECT.O2P_D_PORT           NOT NULL,
   SID                  ORA2PG_PROJECT.O2P_D_NAME           NULL,
   USER_IN_PROJECT_ID   ORA2PG_PROJECT.O2P_D_ID             NULL,
   DEF                  ORA2PG_PROJECT.O2P_D_NY             NOT NULL,
   LOGIN                ORA2PG_PROJECT.O2P_D_USERNAME       NOT NULL,
   PASSWORD             ORA2PG_PROJECT.O2P_D_PASSWORD       NOT NULL,
   SERVICENAME_IN_SID   ORA2PG_PROJECT.O2P_D_NY             NOT NULL
)
WITHOUT OIDS
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_ORACLE_CONNECTION IS 'База данных Oracle, из которой требуется мигрировать';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ORACLE_CONNECTION.ID IS 'ID соединения с БД Oracle';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ORACLE_CONNECTION.ALIAS IS 'Алиас БД';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ORACLE_CONNECTION.HOST IS 'Имя или IP-адрес хоста';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ORACLE_CONNECTION.PORT IS 'Порт';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ORACLE_CONNECTION.SID IS 'Имя инстанса БД';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ORACLE_CONNECTION.USER_IN_PROJECT_ID IS 'ID участника проекта';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ORACLE_CONNECTION.DEF IS 'Признак соединения по умолчанию';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ORACLE_CONNECTION.LOGIN IS 'Имя пользователя для подключения к БД Oracle';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ORACLE_CONNECTION.PASSWORD IS 'Пароль для подключения к БД Oracle';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ORACLE_CONNECTION.SERVICENAME_IN_SID IS 'Признак, показывающий, что в качестве SID указан SERVICE_NAME';

ALTER TABLE ORA2PG_PROJECT.O2P_T_ORACLE_CONNECTION
   ADD CONSTRAINT O2P_T_ORACLE_CONNECTION_PK PRIMARY KEY (ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_ORACLE_CONNECTION_ALIAS_U                       */
/*==============================================================*/
CREATE UNIQUE INDEX O2P_T_ORACLE_CONNECTION_ALIAS_U ON ORA2PG_PROJECT.O2P_T_ORACLE_CONNECTION USING BTREE (
ALIAS,
USER_IN_PROJECT_ID
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_ORACLE_CONNECTION_UINP_FK                       */
/*==============================================================*/
CREATE  INDEX O2P_T_ORACLE_CONNECTION_UINP_FK ON ORA2PG_PROJECT.O2P_T_ORACLE_CONNECTION USING BTREE (
USER_IN_PROJECT_ID
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_ORACLE_CONNECTION
   ADD CONSTRAINT O2P_T_ORACLE_CONNECTION_UINP_FK FOREIGN KEY (USER_IN_PROJECT_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_USER_IN_PROJECT (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;
