/*==============================================================*/
/* Table: O2P_T_ORACLE_DDL                                      */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_ORACLE_DDL (
   ID                   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   ACSESSION4ORADDL_ID  ORA2PG_PROJECT.O2P_D_ID             NULL,
   ORACLE_SCRIPT        ORA2PG_PROJECT.O2P_D_SCRIPT         NOT NULL,
   PO4ORADDL_ID         ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   CREATE_DATE          ORA2PG_PROJECT.O2P_D_DATETIME       NOT NULL
)
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_ORACLE_DDL IS 'DDL-  ,    Oracle';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ORACLE_DDL.ID IS 'ID DDL-';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ORACLE_DDL.ACSESSION4ORADDL_ID IS 'ID  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ORACLE_DDL.ORACLE_SCRIPT IS ' DDL-';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ORACLE_DDL.PO4ORADDL_ID IS 'ID  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_ORACLE_DDL.CREATE_DATE IS '    ';

ALTER TABLE ORA2PG_PROJECT.O2P_T_ORACLE_DDL
   ADD CONSTRAINT O2P_T_ORACLE_DDL_PK PRIMARY KEY (ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_PO4ORADDL_FK                                    */
/*==============================================================*/
CREATE  INDEX O2P_T_PO4ORADDL_FK ON ORA2PG_PROJECT.O2P_T_ORACLE_DDL (
PO4ORADDL_ID
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_ACSESSION4ORADDL_FK                             */
/*==============================================================*/
CREATE  INDEX O2P_T_ACSESSION4ORADDL_FK ON ORA2PG_PROJECT.O2P_T_ORACLE_DDL (
ACSESSION4ORADDL_ID
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_ORACLE_DDL
   ADD CONSTRAINT O2P_T_ACSESSION4ORADDL_FK FOREIGN KEY (ACSESSION4ORADDL_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_ACSESSION (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_ORACLE_DDL
   ADD CONSTRAINT O2P_T_PO4ORADDL_FK FOREIGN KEY (PO4ORADDL_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_PROJECT_OBJECT (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_PROJECT_OBJECT
   ADD CONSTRAINT O2P_T_ORADDL4PO_FK FOREIGN KEY (ORADDL4PO_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_ORACLE_DDL (ID)
      ON DELETE SET NULL ON UPDATE RESTRICT;
