﻿/*==============================================================*/
/* Table: O2P_T_PARAMETER_VALUE                                 */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE (
   ID                   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   O4PARVAL_ID          O2P_D_ID             NULL,
   PAR4VAL_CODE         O2P_D_CODE32         NULL,
   PARVALUE             O2P_D_TEXT           NULL,
   NOTES                O2P_D_NOTES          NULL,
   STEP4PARVAL_ID       ORA2PG_PROJECT.O2P_D_ID             NULL,
   PROJECT4PARVAL_CODE  ORA2PG_PROJECT.O2P_D_CODE32         NULL,
   SET_OFF              ORA2PG_PROJECT.O2P_D_NY             NOT NULL
)
WITHOUT OIDS
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE IS 'Значение конфигурационного параметра';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE.ID IS 'ID значения параметра';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE.O4PARVAL_ID IS 'ID объекта миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE.PAR4VAL_CODE IS 'Код параметра миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE.PARVALUE IS 'Значение конфигурационного параметра';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE.NOTES IS 'Примечания к значению конфигурационного параметра';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE.STEP4PARVAL_ID IS 'ID этапа миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE.PROJECT4PARVAL_CODE IS 'Код проекта';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE.SET_OFF IS 'Признак отключённого параметра';

ALTER TABLE ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE
   ADD CONSTRAINT O2P_T_PARAMETER_VALUE_PK PRIMARY KEY (ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_PARAMETER_VALUE_O4PARVAL_FK                     */
/*==============================================================*/
CREATE  INDEX O2P_T_PARAMETER_VALUE_O4PARVAL_FK ON ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE USING BTREE (
O4PARVAL_ID
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_PARAMETER_VALUE_PAR4VAL_FK                      */
/*==============================================================*/
CREATE  INDEX O2P_T_PARAMETER_VALUE_PAR4VAL_FK ON ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE USING BTREE (
PAR4VAL_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_PARAMETER_VALUE_STEP4PARVAL_FK                  */
/*==============================================================*/
CREATE  INDEX O2P_T_PARAMETER_VALUE_STEP4PARVAL_FK ON ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE (
STEP4PARVAL_ID
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_PARAMETER_VALUE_PROJECT4PARVAL_FK               */
/*==============================================================*/
CREATE  INDEX O2P_T_PARAMETER_VALUE_PROJECT4PARVAL_FK ON ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE (
PROJECT4PARVAL_CODE
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE
   ADD CONSTRAINT O2P_T_PARAMETER_VALUE_O4PARVAL_FK FOREIGN KEY (O4PARVAL_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_OBJECT (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE
   ADD CONSTRAINT O2P_T_PARAMETER_VALUE_PAR4VAL_FK FOREIGN KEY (PAR4VAL_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_PARAMETER (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE
   ADD CONSTRAINT O2P_T_PARAMETER_VALUE_PROJECT4PARVAL_FK FOREIGN KEY (PROJECT4PARVAL_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_PROJECT (CODE)
      ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_PARAMETER_VALUE
   ADD CONSTRAINT O2P_T_PARAMETER_VALUE_STEP4PARVAL_FK FOREIGN KEY (STEP4PARVAL_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_STEP (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;
