/*==============================================================*/
/* Table: O2P_T_PO2ACSESSION                                    */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_PO2ACSESSION (
   ACSESSION4PO_ID      ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   PO4ACSESSION_ID      ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   RESCODE4PO_CODE      ORA2PG_PROJECT.O2P_D_CODE32         NULL,
   PROBLEM_TEXT         ORA2PG_PROJECT.O2P_D_DESCRIPTION    NULL
)
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_PO2ACSESSION IS ' ,   c ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PO2ACSESSION.ACSESSION4PO_ID IS 'ID  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PO2ACSESSION.PO4ACSESSION_ID IS 'ID  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PO2ACSESSION.RESCODE4PO_CODE IS '   ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PO2ACSESSION.PROBLEM_TEXT IS ' ';

ALTER TABLE ORA2PG_PROJECT.O2P_T_PO2ACSESSION
   ADD CONSTRAINT O2P_T_PO2ACSESSION_PK PRIMARY KEY (ACSESSION4PO_ID, PO4ACSESSION_ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_ACSESSION4PROBLEM_FK                            */
/*==============================================================*/
CREATE  INDEX O2P_T_ACSESSION4PROBLEM_FK ON ORA2PG_PROJECT.O2P_T_PO2ACSESSION (
ACSESSION4PO_ID
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_PO4PROBLEM_FK                                   */
/*==============================================================*/
CREATE  INDEX O2P_T_PO4PROBLEM_FK ON ORA2PG_PROJECT.O2P_T_PO2ACSESSION (
PO4ACSESSION_ID
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_RESCODE4PO_FK                                   */
/*==============================================================*/
CREATE  INDEX O2P_T_RESCODE4PO_FK ON ORA2PG_PROJECT.O2P_T_PO2ACSESSION (
RESCODE4PO_CODE
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_PO2ACSESSION
   ADD CONSTRAINT O2P_T_ACSESSION4PO_FK FOREIGN KEY (ACSESSION4PO_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_ACSESSION (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_PO2ACSESSION
   ADD CONSTRAINT O2P_T_PO4ACSESSION_FK FOREIGN KEY (PO4ACSESSION_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_PROJECT_OBJECT (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_PO2ACSESSION
   ADD CONSTRAINT O2P_T_RESCODE4PO_FK FOREIGN KEY (RESCODE4PO_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_ACSESSION_RESCODE (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;
