/*==============================================================*/
/* Table: O2P_T_PORESPONSIBLE_LOG                               */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG (
   ID                   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   PO4PORESP_ID         ORA2PG_PROJECT.O2P_D_ID             NULL,
   DATESTAMP            ORA2PG_PROJECT.O2P_D_DATETIME       NOT NULL,
   CHANGEUSR4PORESP     ORA2PG_PROJECT.O2P_D_USERNAME       NOT NULL,
   OLDUSR4PORESP        ORA2PG_PROJECT.O2P_D_USERNAME       NULL,
   NEWUSR4PORESP        ORA2PG_PROJECT.O2P_D_USERNAME       NULL,
   OLD_TASK             ORA2PG_PROJECT.O2P_D_TEXT           NULL,
   NEW_TASK             ORA2PG_PROJECT.O2P_D_TEXT           NULL,
   OLDSTATUS4PORESP_CODE ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   NEWSTATUS4PORESP_CODE ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL
);

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG IS '     ,       ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG.ID IS 'ID   ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG.PO4PORESP_ID IS 'ID  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG.DATESTAMP IS '     ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG.CHANGEUSR4PORESP IS ' ,  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG.OLDUSR4PORESP IS '   ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG.NEWUSR4PORESP IS '   ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG.OLD_TASK IS '  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG.NEW_TASK IS '  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG.OLDSTATUS4PORESP_CODE IS '   ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG.NEWSTATUS4PORESP_CODE IS '   ';

ALTER TABLE ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG
   ADD CONSTRAINT O2P_T_PORESPONSIBLE_LOG_PK PRIMARY KEY (ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_CHANGEUSR4PORESP_FK                             */
/*==============================================================*/
CREATE  INDEX O2P_T_CHANGEUSR4PORESP_FK ON ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG (
CHANGEUSR4PORESP
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_OLDUSR4PORESP_FK                                */
/*==============================================================*/
CREATE  INDEX O2P_T_OLDUSR4PORESP_FK ON ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG (
OLDUSR4PORESP
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_NEWUSR4PORESP_FK                                */
/*==============================================================*/
CREATE  INDEX O2P_T_NEWUSR4PORESP_FK ON ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG (
NEWUSR4PORESP
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_OLDSTATUS4PORESP_FK                             */
/*==============================================================*/
CREATE  INDEX O2P_T_OLDSTATUS4PORESP_FK ON ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG (
OLDSTATUS4PORESP_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_NEWSTATUS4PORESP_FK                             */
/*==============================================================*/
CREATE  INDEX O2P_T_NEWSTATUS4PORESP_FK ON ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG (
NEWSTATUS4PORESP_CODE
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG
   ADD CONSTRAINT O2P_T_CHANGEUSR4PORESP_FK FOREIGN KEY (CHANGEUSR4PORESP)
      REFERENCES ORA2PG_PROJECT.O2P_T_USER (USERNAME)
      ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG
   ADD CONSTRAINT O2P_T_NEWSTATUS4PORESP_FK FOREIGN KEY (NEWSTATUS4PORESP_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_POBJECT_STATUS (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG
   ADD CONSTRAINT O2P_T_NEWUSR4PORESP_FK FOREIGN KEY (NEWUSR4PORESP)
      REFERENCES ORA2PG_PROJECT.O2P_T_USER (USERNAME)
      ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG
   ADD CONSTRAINT O2P_T_OLDSTATUS4PORESP_FK FOREIGN KEY (OLDSTATUS4PORESP_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_POBJECT_STATUS (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG
   ADD CONSTRAINT O2P_T_OLDUSR4PORESP_FK FOREIGN KEY (OLDUSR4PORESP)
      REFERENCES ORA2PG_PROJECT.O2P_T_USER (USERNAME)
      ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_PORESPONSIBLE_LOG
   ADD CONSTRAINT O2P_T_PO4PORESP_FK FOREIGN KEY (PO4PORESP_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_PROJECT_OBJECT (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;
