/*==============================================================*/
/* Table: O2P_T_POREVISION                                      */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_POREVISION (
   ID                   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   VERSION_NUMBER       ORA2PG_PROJECT.O2P_D_INTPOS         NOT NULL,
   PO4POREV_ID          ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   USERNAME             ORA2PG_PROJECT.O2P_D_USERNAME       NOT NULL,
   ORACLE_SCRIPT        ORA2PG_PROJECT.O2P_D_SCRIPT         NOT NULL,
   CREATE_DATE          ORA2PG_PROJECT.O2P_D_DATETIME       NOT NULL,
   NOTES                ORA2PG_PROJECT.O2P_D_NOTES          NULL
)
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_POREVISION IS '  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_POREVISION.ID IS 'ID ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_POREVISION.VERSION_NUMBER IS ' ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_POREVISION.PO4POREV_ID IS 'ID  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_POREVISION.USERNAME IS ',  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_POREVISION.ORACLE_SCRIPT IS 'DDL  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_POREVISION.CREATE_DATE IS '    ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_POREVISION.NOTES IS '  ';

ALTER TABLE ORA2PG_PROJECT.O2P_T_POREVISION
   ADD CONSTRAINT O2P_T_POREVISION_PK PRIMARY KEY (ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_USR4POREV_FK                                    */
/*==============================================================*/
CREATE  INDEX O2P_T_USR4POREV_FK ON ORA2PG_PROJECT.O2P_T_POREVISION (
USERNAME
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_PO4POREV_FK                                     */
/*==============================================================*/
CREATE  INDEX O2P_T_PO4POREV_FK ON ORA2PG_PROJECT.O2P_T_POREVISION (
PO4POREV_ID
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_POREVISION
   ADD CONSTRAINT O2P_T_PO4POREV_FK FOREIGN KEY (PO4POREV_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_PROJECT_OBJECT (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_POREVISION
   ADD CONSTRAINT O2P_T_USR4POREV_FK FOREIGN KEY (USERNAME)
      REFERENCES ORA2PG_PROJECT.O2P_T_USER (USERNAME)
      ON DELETE RESTRICT ON UPDATE CASCADE;
