﻿/*==============================================================*/
/* Table: O2P_T_PROJECT                                         */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_PROJECT (
   CODE                 ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   NAME                 ORA2PG_PROJECT.O2P_D_NAME           NOT NULL,
   DESCRIPTION          ORA2PG_PROJECT.O2P_D_DESCRIPTION    NOT NULL,
   NOTES                ORA2PG_PROJECT.O2P_D_NOTES          NULL,
   CONFIG               ORA2PG_PROJECT.O2P_D_SCRIPT         NOT NULL,
   START_DATE           ORA2PG_PROJECT.O2P_D_DATE           NULL,
   FINISH_PLAN_DATE     ORA2PG_PROJECT.O2P_D_DATE           NULL,
   FINISH_FACT_DATE     ORA2PG_PROJECT.O2P_D_DATE           NULL,
   LEVEL4PROJECT_CODE   ORA2PG_PROJECT.O2P_D_CODE32         NULL,
   STATUS4PROJECT_CODE  ORA2PG_PROJECT.O2P_D_CODE32         NULL DEFAULT 'NEW'
)
WITHOUT OIDS
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_PROJECT IS 'Проект миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PROJECT.CODE IS 'Код проекта';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PROJECT.NAME IS 'Наименование проекта';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PROJECT.DESCRIPTION IS 'Описание проекта миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PROJECT.NOTES IS 'Примечания к проекту';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PROJECT.CONFIG IS 'Конфигурация';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PROJECT.START_DATE IS 'Дата начала работы над проектом миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PROJECT.FINISH_PLAN_DATE IS 'Плановая дата начала работы над проектом миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PROJECT.FINISH_FACT_DATE IS 'Фактическая дата завершения работы над проектом миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PROJECT.LEVEL4PROJECT_CODE IS 'Уровень миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_PROJECT.STATUS4PROJECT_CODE IS 'Состояние проекта';

ALTER TABLE ORA2PG_PROJECT.O2P_T_PROJECT
   ADD CONSTRAINT O2P_T_PROJECT_PK PRIMARY KEY (CODE)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_LEVEL4PROJECT_FK                                */
/*==============================================================*/
CREATE  INDEX O2P_T_LEVEL4PROJECT_FK ON ORA2PG_PROJECT.O2P_T_PROJECT (
LEVEL4PROJECT_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_STATUS4PROJECT_FK                               */
/*==============================================================*/
CREATE  INDEX O2P_T_STATUS4PROJECT_FK ON ORA2PG_PROJECT.O2P_T_PROJECT (
STATUS4PROJECT_CODE
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_PROJECT
   ADD CONSTRAINT O2P_T_LEVEL4PROJECT_FK FOREIGN KEY (LEVEL4PROJECT_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_MIGRATION_LEVEL (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_PROJECT
   ADD CONSTRAINT O2P_T_STATUS4PROJECT_FK FOREIGN KEY (STATUS4PROJECT_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_PROJECT_STATUS (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;
