/*==============================================================*/
/* Table: O2P_T_RESPONSIBLE_LOG                                 */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG (
   ID                   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   O4RESP_ID            ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   DATESTAMP            ORA2PG_PROJECT.O2P_D_DATETIME       NOT NULL,
   CHANGEUSR4RESP       ORA2PG_PROJECT.O2P_D_USERNAME       NOT NULL,
   OLDUSR4RESP          ORA2PG_PROJECT.O2P_D_USERNAME       NULL,
   NEWUSR4RESP          ORA2PG_PROJECT.O2P_D_USERNAME       NULL,
   OLD_TASK             ORA2PG_PROJECT.O2P_D_DESCRIPTION    NULL,
   NEW_TASK             ORA2PG_PROJECT.O2P_D_DESCRIPTION    NULL,
   OLDSTATUS4RESP_CODE  ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   NEWSTATUS4RESP_CODE  ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL
)
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG IS '    Postgres';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG.ID IS 'ID  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG.O4RESP_ID IS 'ID   Postgres';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG.DATESTAMP IS '   ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG.CHANGEUSR4RESP IS ' ,  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG.OLDUSR4RESP IS '   ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG.NEWUSR4RESP IS '   ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG.OLD_TASK IS ' ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG.NEW_TASK IS ' ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG.OLDSTATUS4RESP_CODE IS '   Postgres';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG.NEWSTATUS4RESP_CODE IS '   Postgres';

ALTER TABLE ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG
   ADD CONSTRAINT O2P_T_RESPONSIBLE_PK PRIMARY KEY (ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_O4RESP_FK                                       */
/*==============================================================*/
CREATE  INDEX O2P_T_O4RESP_FK ON ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG (
O4RESP_ID
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_OLDUSR4RESP_FK                                  */
/*==============================================================*/
CREATE  INDEX O2P_T_OLDUSR4RESP_FK ON ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG (
OLDUSR4RESP
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_NEWUSR4RESP_FK                                  */
/*==============================================================*/
CREATE  INDEX O2P_T_NEWUSR4RESP_FK ON ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG (
NEWUSR4RESP
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_OLDSTATUS4RESP_FK                               */
/*==============================================================*/
CREATE  INDEX O2P_T_OLDSTATUS4RESP_FK ON ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG (
OLDSTATUS4RESP_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_NEWSTATUS4RESP_FK                               */
/*==============================================================*/
CREATE  INDEX O2P_T_NEWSTATUS4RESP_FK ON ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG (
NEWSTATUS4RESP_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_CHANGEUSR4RESP_FK                               */
/*==============================================================*/
CREATE  INDEX O2P_T_CHANGEUSR4RESP_FK ON ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG (
CHANGEUSR4RESP
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG
   ADD CONSTRAINT O2P_T_CHANGEUSR4RESP_FK FOREIGN KEY (CHANGEUSR4RESP)
      REFERENCES ORA2PG_PROJECT.O2P_T_USER (USERNAME)
      ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG
   ADD CONSTRAINT O2P_T_NEWSTATUS4RESP_FK FOREIGN KEY (NEWSTATUS4RESP_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_OBJECT_STATUS (CODE)
      ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG
   ADD CONSTRAINT O2P_T_NEWUSR4RESP_FK FOREIGN KEY (NEWUSR4RESP)
      REFERENCES ORA2PG_PROJECT.O2P_T_USER (USERNAME)
      ON DELETE SET NULL ON UPDATE RESTRICT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG
   ADD CONSTRAINT O2P_T_O4RESP_FK FOREIGN KEY (O4RESP_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_OBJECT (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG
   ADD CONSTRAINT O2P_T_OLDSTATUS4RRESP_FK FOREIGN KEY (OLDSTATUS4RESP_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_OBJECT_STATUS (CODE)
      ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_RESPONSIBLE_LOG
   ADD CONSTRAINT O2P_T_OLDUSR4RESP_FK FOREIGN KEY (OLDUSR4RESP)
      REFERENCES ORA2PG_PROJECT.O2P_T_USER (USERNAME)
      ON DELETE SET NULL ON UPDATE CASCADE;
