﻿/*==============================================================*/
/* Table: O2P_T_REVISION                                        */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_REVISION (
   ID                   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   VERSION_NUMBER       ORA2PG_PROJECT.O2P_D_INTPOS         NOT NULL,
   O4REV_ID             ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   USERNAME             ORA2PG_PROJECT.O2P_D_USERNAME       NULL,
   ORACLE_SCRIPT        ORA2PG_PROJECT.O2P_D_SCRIPT         NULL,
   POSTGRES_SCRIPT      ORA2PG_PROJECT.O2P_D_SCRIPT         NULL,
   PG_LOG               ORA2PG_PROJECT.O2P_D_LOG            NULL,
   NOTES                ORA2PG_PROJECT.O2P_D_NOTES          NULL,
   CREATE_DATE          ORA2PG_PROJECT.O2P_D_DATETIME       NOT NULL
)
WITHOUT OIDS
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_REVISION IS 'Версия объекта миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_REVISION.ID IS 'ID';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_REVISION.VERSION_NUMBER IS 'Номер версии';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_REVISION.O4REV_ID IS 'ID мигрируемого объекта';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_REVISION.USERNAME IS 'Имя пользователя, ответственного за миграцию объекта';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_REVISION.ORACLE_SCRIPT IS 'DDL-скрипт для создания объекта в Oracle';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_REVISION.POSTGRES_SCRIPT IS 'DLL-скрипт для создания объекта в Postgres';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_REVISION.PG_LOG IS 'Журнал применения DDL-скрипта для Postgres в БД';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_REVISION.NOTES IS 'Примечания к версии объекта';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_REVISION.CREATE_DATE IS 'Дата и время сохранения версии';

ALTER TABLE ORA2PG_PROJECT.O2P_T_REVISION
   ADD CONSTRAINT O2P_T_MIGRATION_REVISION_PK PRIMARY KEY (ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_REVISION_O4REV_FK                               */
/*==============================================================*/
CREATE  INDEX O2P_T_REVISION_O4REV_FK ON ORA2PG_PROJECT.O2P_T_REVISION (
O4REV_ID
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_REVISION_USERNAME_FK                            */
/*==============================================================*/
CREATE  INDEX O2P_T_REVISION_USERNAME_FK ON ORA2PG_PROJECT.O2P_T_REVISION USING BTREE (
USERNAME
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_REVISION
   ADD CONSTRAINT O2P_T_REVISION_O4REV_FK FOREIGN KEY (O4REV_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_OBJECT (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_REVISION
   ADD CONSTRAINT O2P_T_REVISION_USERNAME_FK FOREIGN KEY (USERNAME)
      REFERENCES ORA2PG_PROJECT.O2P_T_USER (USERNAME)
      ON DELETE RESTRICT ON UPDATE RESTRICT;
