﻿/*==============================================================*/
/* Table: O2P_T_RF_ALLOWABLE_PARAMETER_VALUE                    */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_RF_ALLOWABLE_PARAMETER_VALUE (
   PAR4VAL_CODE         ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   NAME                 ORA2PG_PROJECT.O2P_D_NAME           NOT NULL,
   PARVALUE             ORA2PG_PROJECT.O2P_D_TEXT           NOT NULL,
   NOTES                ORA2PG_PROJECT.O2P_D_NOTES          NULL
)
WITHOUT OIDS
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_RF_ALLOWABLE_PARAMETER_VALUE IS 'Возможное значение параметра';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_ALLOWABLE_PARAMETER_VALUE.PAR4VAL_CODE IS 'Код параметра миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_ALLOWABLE_PARAMETER_VALUE.NAME IS 'Наименование значения параметра';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_ALLOWABLE_PARAMETER_VALUE.PARVALUE IS 'Возможное значение';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_ALLOWABLE_PARAMETER_VALUE.NOTES IS 'Примечания к значению параметра';

ALTER TABLE ORA2PG_PROJECT.O2P_T_RF_ALLOWABLE_PARAMETER_VALUE
   ADD CONSTRAINT O2P_T_RF_ALLOWABLE_PARAMETER_VALUE_PK PRIMARY KEY (PAR4VAL_CODE, NAME, PARVALUE)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_RF_ALLOWABLE_PARVALUE_PAR                       */
/*==============================================================*/
CREATE  INDEX O2P_T_RF_ALLOWABLE_PARVALUE_PAR ON ORA2PG_PROJECT.O2P_T_RF_ALLOWABLE_PARAMETER_VALUE USING BTREE (
PAR4VAL_CODE
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_RF_ALLOWABLE_PARAMETER_VALUE
   ADD CONSTRAINT O2P_T_RF_ALLOWABLE_PARVALUE_PAR4VAL_FK FOREIGN KEY (PAR4VAL_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_PARAMETER (CODE)
      ON DELETE CASCADE ON UPDATE CASCADE;
