/*==============================================================*/
/* Table: O2P_T_RF_MOTYPE2RESTRICTION                           */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_RF_MOTYPE2RESTRICTION (
   MOTYPE_CODE          ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   RESTRICTION_CODE     ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL
);

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_RF_MOTYPE2RESTRICTION IS '  ,    ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_MOTYPE2RESTRICTION.MOTYPE_CODE IS '   ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_MOTYPE2RESTRICTION.RESTRICTION_CODE IS ' ';

ALTER TABLE ORA2PG_PROJECT.O2P_T_RF_MOTYPE2RESTRICTION
   ADD CONSTRAINT O2P_T_MOTYPE2RESTRICTION_PK PRIMARY KEY (MOTYPE_CODE, RESTRICTION_CODE)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_RESTRICTION4MOTYPE_FK                           */
/*==============================================================*/
CREATE  INDEX O2P_T_RESTRICTION4MOTYPE_FK ON ORA2PG_PROJECT.O2P_T_RF_MOTYPE2RESTRICTION (
RESTRICTION_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_MOTYPE4RESTRICTION_FK                           */
/*==============================================================*/
CREATE  INDEX O2P_T_MOTYPE4RESTRICTION_FK ON ORA2PG_PROJECT.O2P_T_RF_MOTYPE2RESTRICTION (
MOTYPE_CODE
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_RF_MOTYPE2RESTRICTION
   ADD CONSTRAINT O2P_T_MOTYPE4RESTRICTION_FK FOREIGN KEY (MOTYPE_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_OBJECT_TYPE (CODE)
      ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_RF_MOTYPE2RESTRICTION
   ADD CONSTRAINT O2P_T_RESTRICTION4MOTYPE_FK FOREIGN KEY (RESTRICTION_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_RESTRICTION_TYPE (CODE)
      ON DELETE CASCADE ON UPDATE CASCADE;
