﻿/*==============================================================*/
/* Table: O2P_T_RF_OBJECT_TYPE                                  */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_RF_OBJECT_TYPE (
   CODE                 ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   NAME                 ORA2PG_PROJECT.O2P_D_NAME           NOT NULL,
   DESCRIPTION          ORA2PG_PROJECT.O2P_D_DESCRIPTION    NOT NULL,
   NOTES                ORA2PG_PROJECT.O2P_D_NOTES          NULL,
   CAT4POTYPE_CODE      ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL
)
WITHOUT OIDS
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_RF_OBJECT_TYPE IS 'Типы объектов проекта';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_OBJECT_TYPE.CODE IS 'Код типа объектов проекта';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_OBJECT_TYPE.NAME IS 'Наименование типа объектов проекта';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_OBJECT_TYPE.DESCRIPTION IS 'Описание особенностей миграции данного типа объектов проекта';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_OBJECT_TYPE.NOTES IS 'Примечания к типу объектов проекта';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_OBJECT_TYPE.CAT4POTYPE_CODE IS 'Категория типа объектов проекта';

ALTER TABLE ORA2PG_PROJECT.O2P_T_RF_OBJECT_TYPE
   ADD CONSTRAINT O2P_T_RF_OBJECT_TYPE_PK PRIMARY KEY (CODE)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_CAT4POTYPE_FK                                   */
/*==============================================================*/
CREATE  INDEX O2P_T_CAT4POTYPE_FK ON ORA2PG_PROJECT.O2P_T_RF_OBJECT_TYPE (
CAT4POTYPE_CODE
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_RF_OBJECT_TYPE
   ADD CONSTRAINT O2P_T_CAT4POTYPE_FK FOREIGN KEY (CAT4POTYPE_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_CATEGORY (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;
