﻿/*==============================================================*/
/* Table: O2P_T_RF_PARAMETER                                    */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_RF_PARAMETER (
   CODE                 ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   NAME                 ORA2PG_PROJECT.O2P_D_NAME           NOT NULL,
   DEFAULT_VALUE        ORA2PG_PROJECT.O2P_D_TEXT           NULL,
   GROUP4PAR_CODE       ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   DT4PAR_NAME          ORA2PG_PROJECT.O2P_D_NAME           NOT NULL,
   NOTES                ORA2PG_PROJECT.O2P_D_NOTES          NULL,
   DESCRIPTION          ORA2PG_PROJECT.O2P_D_DESCRIPTION    NOT NULL,
   INITIALLY_OFF        ORA2PG_PROJECT.O2P_D_NY             NOT NULL,
   NUM                  ORA2PG_PROJECT.O2P_D_INTPOS         NOT NULL,
   MULTIPLE             ORA2PG_PROJECT.O2P_D_NY             NOT NULL,
   DT4PAR_FORMAT        ORA2PG_PROJECT.O2P_D_TEXT           NULL,
   CHANGEABLE           ORA2PG_PROJECT.O2P_D_YN             NOT NULL
)
WITHOUT OIDS
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_RF_PARAMETER IS 'Параметр конфигурации';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_PARAMETER.CODE IS 'Код конфигурационного параметра';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_PARAMETER.NAME IS 'Наименование конфигурационного параметра';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_PARAMETER.DEFAULT_VALUE IS 'Значение по умолчанию конфигрурационного параметра';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_PARAMETER.GROUP4PAR_CODE IS 'Код группы конфигурационных параметров';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_PARAMETER.DT4PAR_NAME IS 'Тип данных в значении конфигурационного параметра';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_PARAMETER.NOTES IS 'Примечания к параметру';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_PARAMETER.DESCRIPTION IS 'Описание параметра';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_PARAMETER.INITIALLY_OFF IS 'Изначально отключён';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_PARAMETER.NUM IS 'Порядковый номер параметра';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_PARAMETER.MULTIPLE IS 'Может ли параметр быть указан многократно';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_PARAMETER.DT4PAR_FORMAT IS 'Формат числа или даты';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_PARAMETER.CHANGEABLE IS 'Допускается ли изменение параметра пользователем';

ALTER TABLE ORA2PG_PROJECT.O2P_T_RF_PARAMETER
   ADD CONSTRAINT O2P_T_RF_PARAMETER_PK PRIMARY KEY (CODE)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_RF_PARAMETER_DT_FK                              */
/*==============================================================*/
CREATE  INDEX O2P_T_RF_PARAMETER_DT_FK ON ORA2PG_PROJECT.O2P_T_RF_PARAMETER USING BTREE (
DT4PAR_NAME
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_RF_PARAMETER_GRP_FK                             */
/*==============================================================*/
CREATE  INDEX O2P_T_RF_PARAMETER_GRP_FK ON ORA2PG_PROJECT.O2P_T_RF_PARAMETER USING BTREE (
GROUP4PAR_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_RF_PARAMETER_NUM_UK                             */
/*==============================================================*/
CREATE UNIQUE INDEX O2P_T_RF_PARAMETER_NUM_UK ON ORA2PG_PROJECT.O2P_T_RF_PARAMETER USING BTREE (
NUM
);

ALTER TABLE ORA2PG_PROJECT.O2P_T_RF_PARAMETER
   ADD CONSTRAINT O2P_T_RF_PARAMETER_DT_FK FOREIGN KEY (DT4PAR_NAME)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_DATATYPE (NAME)
      ON DELETE RESTRICT ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_RF_PARAMETER
   ADD CONSTRAINT O2P_T_RF_PARAMETER_GRP_FK FOREIGN KEY (GROUP4PAR_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_CONFIG_GROUP (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;
