/*==============================================================*/
/* Table: O2P_T_RF_POSTGRES_TYPE                                */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_RF_POSTGRES_TYPE (
   CODE                 ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   NAME                 ORA2PG_PROJECT.O2P_D_NAME           NOT NULL,
   NOTES                ORA2PG_PROJECT.O2P_D_NOTES          NULL,
   CAT4OTYPE_CODE       ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL
)
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_RF_POSTGRES_TYPE IS '  Postgres';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_POSTGRES_TYPE.CODE IS '   Postgres';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_POSTGRES_TYPE.NAME IS '   Postgres';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_POSTGRES_TYPE.NOTES IS '    Postgres';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_RF_POSTGRES_TYPE.CAT4OTYPE_CODE IS '   Postgres';

ALTER TABLE ORA2PG_PROJECT.O2P_T_RF_POSTGRES_TYPE
   ADD CONSTRAINT O2P_T_RF_POSTGRES_TYPE_PK PRIMARY KEY (CODE)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_CAT4OTYPE_FK                                    */
/*==============================================================*/
CREATE  INDEX O2P_T_CAT4OTYPE_FK ON ORA2PG_PROJECT.O2P_T_RF_POSTGRES_TYPE (
CAT4OTYPE_CODE
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_RF_POSTGRES_TYPE
   ADD CONSTRAINT O2P_T_CAT4OTYPE_FK FOREIGN KEY (CAT4OTYPE_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_CATEGORY (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;
