﻿/*==============================================================*/
/* Table: O2P_T_STEP                                            */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_STEP (
   ID                   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   NAME                 ORA2PG_PROJECT.O2P_D_NAME           NOT NULL,
   NUM                  ORA2PG_PROJECT.O2P_D_INTPOS         NOT NULL,
   DESCRIPTION          ORA2PG_PROJECT.O2P_D_DESCRIPTION    NOT NULL,
   NOTES                ORA2PG_PROJECT.O2P_D_NOTES          NULL,
   PROJECT4STEP_CODE    ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   STATUS4STEP_CODE     ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   STEPTYPE_CODE        ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL
)
WITHOUT OIDS
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_STEP IS 'Этап миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP.ID IS 'ID';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP.NAME IS 'Наименование этапа миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP.NUM IS 'Порядковый номер этапа миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP.DESCRIPTION IS 'Описание этапа миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP.NOTES IS 'Примечания к процессу миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP.PROJECT4STEP_CODE IS 'Код проекта миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP.STATUS4STEP_CODE IS 'Код состояния этапа миграции';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP.STEPTYPE_CODE IS 'Код типа этапов миграции';

ALTER TABLE ORA2PG_PROJECT.O2P_T_STEP
   ADD CONSTRAINT O2P_T_STEP_PK PRIMARY KEY (ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_STEP_PROJECT4STEP_FK                            */
/*==============================================================*/
CREATE  INDEX O2P_T_STEP_PROJECT4STEP_FK ON ORA2PG_PROJECT.O2P_T_STEP USING BTREE (
PROJECT4STEP_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_STEP_STATUS_FK                                  */
/*==============================================================*/
CREATE  INDEX O2P_T_STEP_STATUS_FK ON ORA2PG_PROJECT.O2P_T_STEP USING BTREE (
STATUS4STEP_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_STEP_TYPE_FK                                    */
/*==============================================================*/
CREATE  INDEX O2P_T_STEP_TYPE_FK ON ORA2PG_PROJECT.O2P_T_STEP (
STEPTYPE_CODE
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_STEP
   ADD CONSTRAINT O2P_T_STEP_PROJECT4STEP_FK FOREIGN KEY (PROJECT4STEP_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_PROJECT (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_STEP
   ADD CONSTRAINT O2P_T_STEP_STATUS_FK FOREIGN KEY (STATUS4STEP_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_STEP_STATUS (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE DEFERRABLE INITIALLY IMMEDIATE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_STEP
   ADD CONSTRAINT O2P_T_STEP_TYPE_FK FOREIGN KEY (STEPTYPE_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_STEP_TYPE (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;
