/*==============================================================*/
/* Table: O2P_T_STEP_HIST                                       */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_STEP_HIST (
   ID                   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   STEP4HIST_ID         ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   DATESTAMP            ORA2PG_PROJECT.O2P_D_DATETIME       NOT NULL,
   USER4HIST_USERNAME   ORA2PG_PROJECT.O2P_D_NAME           NULL,
   OLD_STATUS4HIST_CODE ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   NEW_STATUS4HIST_CODE ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   CAUSE                ORA2PG_PROJECT.O2P_D_DESCRIPTION    NOT NULL,
   NOTES                ORA2PG_PROJECT.O2P_D_NOTES          NULL
)
WITHOUT OIDS
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_STEP_HIST IS '     ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_HIST.ID IS 'ID      ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_HIST.STEP4HIST_ID IS 'ID  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_HIST.DATESTAMP IS '    ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_HIST.USER4HIST_USERNAME IS ' -  ,    ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_HIST.OLD_STATUS4HIST_CODE IS ' ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_HIST.NEW_STATUS4HIST_CODE IS ' ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_HIST.CAUSE IS '     ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_HIST.NOTES IS '        ';

ALTER TABLE ORA2PG_PROJECT.O2P_T_STEP_HIST
   ADD CONSTRAINT O2P_T_STEP_HIST_PK PRIMARY KEY (ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_STEP_HIST_FK                                    */
/*==============================================================*/
CREATE  INDEX O2P_T_STEP_HIST_FK ON ORA2PG_PROJECT.O2P_T_STEP_HIST USING BTREE (
STEP4HIST_ID
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_STEP_HIST_IOLD_STATUS4HIS                       */
/*==============================================================*/
CREATE  INDEX O2P_T_STEP_HIST_IOLD_STATUS4HIS ON ORA2PG_PROJECT.O2P_T_STEP_HIST USING BTREE (
OLD_STATUS4HIST_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_STEP_HIST_NEW_STATUS4HIST                       */
/*==============================================================*/
CREATE  INDEX O2P_T_STEP_HIST_NEW_STATUS4HIST ON ORA2PG_PROJECT.O2P_T_STEP_HIST USING BTREE (
NEW_STATUS4HIST_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_STEP_HIST_USER4HIST_FK                          */
/*==============================================================*/
CREATE  INDEX O2P_T_STEP_HIST_USER4HIST_FK ON ORA2PG_PROJECT.O2P_T_STEP_HIST USING BTREE (
USER4HIST_USERNAME
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_STEP_HIST
   ADD CONSTRAINT O2P_T_STEP_HIST_FK FOREIGN KEY (STEP4HIST_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_STEP (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_STEP_HIST
   ADD CONSTRAINT O2P_T_STEP_HIST_NEW_STATUS4HIST_CODE_FK FOREIGN KEY (NEW_STATUS4HIST_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_STEP_STATUS (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_STEP_HIST
   ADD CONSTRAINT O2P_T_STEP_HIST_OLD_STATUS4HIST_FK FOREIGN KEY (OLD_STATUS4HIST_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_STEP_STATUS (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_STEP_HIST
   ADD CONSTRAINT O2P_T_STEP_HIST_USER4HIST_FK FOREIGN KEY (USER4HIST_USERNAME)
      REFERENCES ORA2PG_PROJECT.O2P_T_USER (USERNAME)
      ON DELETE CASCADE ON UPDATE CASCADE;
