/*==============================================================*/
/* Table: O2P_T_STEP_SCRIPT                                     */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_STEP_SCRIPT (
   ID                   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   STEP_ID              ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   DATETIME             ORA2PG_PROJECT.O2P_D_DATETIME       NOT NULL,
   PGCONTENT            ORA2PG_PROJECT.O2P_D_TEXT           NULL,
   FILENAME             ORA2PG_PROJECT.O2P_D_NAME           NULL,
   FILEPATH             ORA2PG_PROJECT.O2P_D_NAME           NULL,
   EXECUTION_RESULT_CODE ORA2PG_PROJECT.O2P_D_CODE32         NULL,
   EXECUTION_LOG        ORA2PG_PROJECT.O2P_D_LOG            NULL,
   NOTES                ORA2PG_PROJECT.O2P_D_NOTES          NULL,
   PGSCRIPT_ID          ORA2PG_PROJECT.O2P_D_ID             NULL
)
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_STEP_SCRIPT IS '    Postgres';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_SCRIPT.ID IS 'ID ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_SCRIPT.STEP_ID IS 'ID  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_SCRIPT.DATETIME IS '    ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_SCRIPT.PGCONTENT IS ' ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_SCRIPT.FILENAME IS '  ,     ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_SCRIPT.FILEPATH IS '  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_SCRIPT.EXECUTION_RESULT_CODE IS '     Postgres';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_SCRIPT.EXECUTION_LOG IS '  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_SCRIPT.NOTES IS '  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_STEP_SCRIPT.PGSCRIPT_ID IS 'ID   ';

ALTER TABLE ORA2PG_PROJECT.O2P_T_STEP_SCRIPT
   ADD CONSTRAINT O2P_T_STEP_SCRIPT_PK PRIMARY KEY (ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_STEP4SCRIPT_FK                                  */
/*==============================================================*/
CREATE  INDEX O2P_T_STEP4SCRIPT_FK ON ORA2PG_PROJECT.O2P_T_STEP_SCRIPT (
STEP_ID
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_LTEXT4SCRIPT_FK                                 */
/*==============================================================*/
CREATE  INDEX O2P_T_LTEXT4SCRIPT_FK ON ORA2PG_PROJECT.O2P_T_STEP_SCRIPT (
PGSCRIPT_ID
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_STEP_SCRIPT
   ADD CONSTRAINT O2P_T_LTEXT4SCRIPT_FK FOREIGN KEY (PGSCRIPT_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_LONG_TEXT (ID)
      ON DELETE RESTRICT ON UPDATE RESTRICT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_STEP_SCRIPT
   ADD CONSTRAINT O2P_T_RES4STEPSCRIPT_FK FOREIGN KEY (EXECUTION_RESULT_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_RF_RES4STEPSCRIPT (CODE)
      ON DELETE RESTRICT ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_STEP_SCRIPT
   ADD CONSTRAINT O2P_T_STEP4SCRIPT_FK FOREIGN KEY (STEP_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_STEP (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;
