/*==============================================================*/
/* Table: O2P_T_TAB_COLUMN                                      */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_TAB_COLUMN (
   ID                   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   SRC_COL_NAME         ORA2PG_PROJECT.O2P_D_NAME           NOT NULL,
   DST_COLNAME          ORA2PG_PROJECT.O2P_D_NAME           NOT NULL,
   SRC_COL_DATATYPE     ORA2PG_PROJECT.O2P_D_NAME           NOT NULL,
   DST_COL_DATATYPE     ORA2PG_PROJECT.O2P_D_NAME           NULL,
   NOTES                ORA2PG_PROJECT.O2P_D_NOTES          NULL,
   DST_DATATYPE_MAXLEN  ORA2PG_PROJECT.O2P_D_NUMBER         NULL,
   DST_DATATYPE_DECLEN  ORA2PG_PROJECT.O2P_D_NUMBER         NULL,
   SRC_DATATYPE_MAXLEN  ORA2PG_PROJECT.O2P_D_NUMBER         NULL,
   SRC_DATATYPE_DECLEN  ORA2PG_PROJECT.O2P_D_NUMBER         NULL,
   PO4TABCOL_ID         ORA2PG_PROJECT.O2P_D_ID             NULL
)
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_TAB_COLUMN IS '  ,  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_TAB_COLUMN.ID IS 'ID  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_TAB_COLUMN.SRC_COL_NAME IS '   Oracle';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_TAB_COLUMN.DST_COLNAME IS '    postgres';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_TAB_COLUMN.SRC_COL_DATATYPE IS '    Oracle';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_TAB_COLUMN.DST_COL_DATATYPE IS '    postgres';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_TAB_COLUMN.NOTES IS '  ';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_TAB_COLUMN.DST_DATATYPE_MAXLEN IS '     Postgres (    )';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_TAB_COLUMN.DST_DATATYPE_DECLEN IS '    Postgres ( )';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_TAB_COLUMN.SRC_DATATYPE_MAXLEN IS '    Oracle (    )';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_TAB_COLUMN.SRC_DATATYPE_DECLEN IS '    Oracle ( )';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_TAB_COLUMN.PO4TABCOL_ID IS 'ID  ,  ';

ALTER TABLE ORA2PG_PROJECT.O2P_T_TAB_COLUMN
   ADD CONSTRAINT O2P_T_TAB_COLUMN_PK PRIMARY KEY (ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: OP2P_T_PO4TABCOL_FK                                   */
/*==============================================================*/
CREATE  INDEX OP2P_T_PO4TABCOL_FK ON ORA2PG_PROJECT.O2P_T_TAB_COLUMN (
PO4TABCOL_ID
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_TAB_COLUMN
   ADD CONSTRAINT O2P_T_PO4TABCOL_FK FOREIGN KEY (PO4TABCOL_ID)
      REFERENCES ORA2PG_PROJECT.O2P_T_PROJECT_OBJECT (ID)
      ON DELETE CASCADE ON UPDATE RESTRICT;
