﻿/*==============================================================*/
/* Table: O2P_T_USER_IN_PROJECT                                 */
/*==============================================================*/
CREATE TABLE ORA2PG_PROJECT.O2P_T_USER_IN_PROJECT (
   ID                   ORA2PG_PROJECT.O2P_D_ID             NOT NULL,
   IS_LEADER            ORA2PG_PROJECT.O2P_D_NY             NOT NULL,
   USER_USERNAME        ORA2PG_PROJECT.O2P_D_USERNAME       NOT NULL,
   PROJECT4USR_CODE     ORA2PG_PROJECT.O2P_D_CODE32         NOT NULL,
   DATE_FROM            ORA2PG_PROJECT.O2P_D_DATE           NOT NULL,
   DATE_TO              ORA2PG_PROJECT.O2P_D_DATE           NOT NULL
)
WITHOUT OIDS
TABLESPACE ORA2PG_PROJECT;

COMMENT ON TABLE ORA2PG_PROJECT.O2P_T_USER_IN_PROJECT IS 'Участник проекта';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_USER_IN_PROJECT.ID IS 'ID участника проекта';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_USER_IN_PROJECT.IS_LEADER IS 'Руководитель проекта';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_USER_IN_PROJECT.USER_USERNAME IS 'Имя пользователя';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_USER_IN_PROJECT.PROJECT4USR_CODE IS 'Код проекта, в котором участвует пользователь';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_USER_IN_PROJECT.DATE_FROM IS 'Дата начала участия в проекте';

COMMENT ON COLUMN ORA2PG_PROJECT.O2P_T_USER_IN_PROJECT.DATE_TO IS 'Дата завершения участия  в проекте';

ALTER TABLE ORA2PG_PROJECT.O2P_T_USER_IN_PROJECT
   ADD CONSTRAINT O2P_T_USER_IN_PROJECT_PKEY PRIMARY KEY (ID)
   USING INDEX TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_PROJECT4UINP_FK                                 */
/*==============================================================*/
CREATE  INDEX O2P_T_PROJECT4UINP_FK ON ORA2PG_PROJECT.O2P_T_USER_IN_PROJECT USING BTREE (
PROJECT4USR_CODE
) TABLESPACE ORA2PG_PROJECT;

/*==============================================================*/
/* Index: O2P_T_USERNAME4UINP_FK                                */
/*==============================================================*/
CREATE  INDEX O2P_T_USERNAME4UINP_FK ON ORA2PG_PROJECT.O2P_T_USER_IN_PROJECT USING BTREE (
USER_USERNAME
) TABLESPACE ORA2PG_PROJECT;

ALTER TABLE ORA2PG_PROJECT.O2P_T_USER_IN_PROJECT
   ADD CONSTRAINT O2P_T_PROJECT4UINP_FK FOREIGN KEY (PROJECT4USR_CODE)
      REFERENCES ORA2PG_PROJECT.O2P_T_PROJECT (CODE)
      ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE ORA2PG_PROJECT.O2P_T_USER_IN_PROJECT
   ADD CONSTRAINT O2P_T_USERNAME4UINP_FK FOREIGN KEY (USER_USERNAME)
      REFERENCES ORA2PG_PROJECT.O2P_T_USER (USERNAME)
      ON DELETE RESTRICT ON UPDATE CASCADE;
