CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_c2t (
  p_collection ora2pg_project.o2p_d_text
)
RETURNS TABLE (
  key ora2pg_project.o2p_d_text,
  value ora2pg_project.o2p_d_text
) AS
$body$
DECLARE
RealDef o2p_d_text;
PartDef o2p_d_text;
PartMask o2p_d_text;
RealMask o2p_d_text;
PartElems o2p_d_text;
RealValue o2p_d_text;
E record;
BEGIN --    . Default 
  PartMask:=substring(';'||p_collection, ';([^;]+?)$'); --    
  RealMask:=coalesce(PartMask, '#$'); --       -     
  PartMask:=coalesce(PartMask, '');
  PartDef:=coalesce(substring(p_collection, '^.*?;'), ''); --         
  if position(':' in PartDef)>0 then -- PartDef -   Default,    
    PartDef:=null;
  end if;
  RealDef:=coalesce(PartDef, '');
  PartElems=coalesce(substring(p_collection from char_length(RealDef)+1 for char_length(p_collection)-char_length(RealDef)-char_length(PartMask)), '');
--  OPEN E FOR select regexp_matches[1] as cKey, regexp_matches[2] as cValue from regexp_matches(PartElems, '([^:]*):([^;]*);', 'g');
--  Return E;
  for E in (select regexp_matches[1] as cKey, regexp_matches[2] as cValue from regexp_matches(PartElems, '([^:]*):([^;]*);', 'g')) loop
    Key:=replace(E.cKey, RealMask, ':');
    Value:=replace(E.cValue, RealMask, ';');
    return next;
  end loop;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100 ROWS 1000;

ALTER FUNCTION ora2pg_project.o2p_f_c2t (p_collection ora2pg_project.o2p_d_text)
  OWNER TO ora2pg_project;