CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_change_leader_in_project (
  p_leader_username ora2pg_project.o2p_d_name,
  p_project_code ora2pg_project.o2p_d_code32,
  p_date_from ora2pg_project.o2p_d_date,
  p_date_to ora2pg_project.o2p_d_date = o2p_f_get_defhist_to()
)
RETURNS ora2pg_project.o2p_d_text AS
$body$
DECLARE
  uip record;
  cnt o2p_d_number;
  res o2p_d_text;
BEGIN
  -- 1.   ,        p_date_from  p_date_to
  for uip in
      (select *
         from o2p_t_user_in_project
	    where is_leader = 'Y'
		  and project4usr_code = p_project_code
	      and p_date_from between date_from and date_to)
  loop
    --        -      ,   .     .
	--          (o2p_f_save_user_in_project).
	if uip.user_username = p_leader_username then
	  --      
      return 'ShowMessage:O2P-00006;p1:'||uip.user_username||';p2:'||p_leader_username||';p3:'||p_project_code||';';
	end if;
	-- 1.1.     ,   ,       p_date_from, ...
	if uip.date_from >= p_date_from then
	  --           ( p_date_from  p_date_to), ...
	  if uip.date_to <= p_date_to then
	     --         uip.date_from  uip.date_to
		 res := o2p_f_save_user_in_project(uip.id, uip.user_username, uip.project4usr_code, 'N', uip.date_from, uip.date_to);
		 if res > ' ' then return res; end if;
	  else
	    --         uip.date_from  p_date_to-1
		res := o2p_f_save_user_in_project(uip.id, uip.user_username, uip.project4usr_code, 'N', uip.date_from, p_date_to-1);
		if res > ' ' then return res; end if;
		--    p_date_to+1 (..       p_leader_username)   uip.date_to  uip.user_username
		--    
		res := o2p_f_save_user_in_project(null, uip.user_username, uip.project4usr_code, 'N', p_date_to+1, uip.date_to);
		if res > ' ' then return res; end if;
	  end if;
    -- 1.2. 
	else
	  --         
	  res := o2p_f_save_user_in_project(uip.id, uip.user_username, uip.project4usr_code, 'Y', uip.date_from, p_date_from -1);
	  if res > ' ' then return res; end if;
	  --    ,           p_date_from   uip.date_to
	  res := o2p_f_save_user_in_project(null, uip.user_username, uip.project4usr_code, 'N', p_date_from, least(uip.date_to,p_date_to));
	  if res > ' ' then return res; end if;
	  --          p_date_to, ...
	  if uip.date_to > p_date_to then
	    --     ,    p_date_to+1 (..       p_leader_username)
		--   uip.date_to  uip.user_username    
	    res := o2p_f_save_user_in_project(null, uip.user_username, uip.project4usr_code, 'Y', p_date_to+1, uip.date_to);
	    if res > ' ' then return res; end if;
	  end if;
	end if;
  end loop;

  -- 2.      ,    ,        p_date_from  p_date_to
  for uip in
      (select *
         from o2p_t_user_in_project
	    where user_username = p_leader_username
		  and project4usr_code = p_project_code
	      and p_date_from between date_from and date_to)
  loop
	-- 2.1.     ,         p_date_from, ...
	if uip.date_from >= p_date_from then
	  --           ( p_date_from  p_date_to), ...
	  if uip.date_to <= p_date_to then
	     --  
		 delete from o2p_t_user_in_project where id = uip.id;
	  else
		--   p_date_to+1 (..       p_leader_username)   uip.date_to  uip.user_username
		--      
		res := o2p_f_save_user_in_project(uip.id, uip.user_username, uip.project4usr_code, 'N', p_date_to+1, uip.date_to);
		if res > ' ' then return res; end if;
	  end if;
    -- 2.2. 
	else
      --     
	  res := o2p_f_save_user_in_project(uip.id, uip.user_username, uip.project4usr_code, 'N', uip.date_from, p_date_from -1);
	  if res > ' ' then return res; end if;
	  --         p_date_to, ...
	  if uip.date_to > p_date_to then
	    --     ,      p_date_to+1        
	    res := o2p_f_save_user_in_project(null, uip.user_username, uip.project4usr_code, 'N', p_date_to+1, uip.date_to);
	    if res > ' ' then return res; end if;
	  end if;
	end if;
  end loop;

  -- 3.      
  res := o2p_f_save_user_in_project(null, p_leader_username, p_project_code, 'Y', p_date_from, p_date_to);
  if res > ' ' then return res; end if;

  return '';
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_change_leader_in_project (p_leader_username ora2pg_project.o2p_d_name, p_project_code ora2pg_project.o2p_d_code32, p_date_from ora2pg_project.o2p_d_date, p_date_to ora2pg_project.o2p_d_date)
  OWNER TO ora2pg_project;