CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_find_pkgname4str (
  p_vstr text,
  p_vsrctext text,
  p_vpkgtype text
)
RETURNS text AS
$body$
declare
    nIdxTo integer;
    vStr text;
    r record;
    pkg record;
    pkgname text;
    fncname text;
  begin
    vStr := p_vstr;
    if lower(p_vsrctext) not like '%'||lower(p_vPkgType)||'\_%' escape '\' then return vStr; end if;
    
    for r in (select num,value from o2p_f_l2t(upper(p_vsrctext),upper(p_vpkgtype)||'_')) loop
    	continue when r.num=1;
        for pkg in (select num,value from o2p_f_l2t(r.value,'.')) loop
            if pkg.num=1 then
                pkgname := p_vpkgtype||'_'||pkg.value;
            elsif pkg.num=2 then
                nIdxTo := position('(' in pkg.value);
                if nIdxTo=0 then
                    nIdxTo := position(';' in pkg.value);
                    if nIdxTo=0 then
                        nIdxTo := position(' ' in pkg.value);
                    end if;
                end if;
                if nIdxTo=0 then fncname := pkg.value;
                else fncname := substring(pkg.value from 1 for nIdxTo-1);
                end if;
            else exit;
            end if;
        end loop;
        if ';'||coalesce(vStr,'')||';' not like '%;'||pkgname||'.'||fncname||';%' then
            vStr := coalesce(vStr,'')||';'||pkgname||'.'||fncname;
        end if;
    end loop;
    return trim(leading ';' from vStr);
  end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_find_pkgname4str (p_vstr text, p_vsrctext text, p_vpkgtype text)
  OWNER TO ora2pg_project;