CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_get_motype2restriction (
  p_restriction_code ora2pg_project.o2p_d_code32
)
RETURNS text AS
$body$
DECLARE
  r record;
  l text;
BEGIN
  for r in (select motype_code from o2p_t_rf_motype2restriction where restriction_code=p_restriction_code order by 1) loop
    l := coalesce(l,'')||', '||r.motype_code;
  end loop;
return trim(leading ',' from l);
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
RETURNS NULL ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_get_motype2restriction (p_restriction_code ora2pg_project.o2p_d_code32)
  OWNER TO ora2pg_project;