CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_get_parameter_setoff (
  p_parameter_code text,
  p_project_code text = NULL::text
)
RETURNS text AS
$body$
DECLARE
 par record;
 val record;
 isvalexists boolean;
 stepid numeric;
 pcode text;
 res text;
BEGIN
 res := null;
 if p_parameter_code is null then return res; end if;
 
 for par in (select code,initially_off from o2p_t_rf_parameter where code=p_parameter_code) loop
   isvalexists := false;
   if p_project_code is not null then --  
    select min(code) into pcode from o2p_t_project where code=p_project_code;
    exit when pcode is null;
    for val in (select set_off from o2p_t_parameter_value where par4val_code=par.code and project4parval_code=p_project_code) loop
     isvalexists := true;
     res := val.set_off;
    end loop;
    if not isvalexists then
     res := o2p_f_get_parameter_setoff(p_parameter_code,null);
    end if;
   else
    res := par.initially_off;
   end if;
 end loop;
 return res;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY DEFINER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_get_parameter_setoff (p_parameter_code text, p_project_code text)
  OWNER TO ora2pg_project;