CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_get_pgtype_4_oratype (
  p_oratype ora2pg_project.o2p_d_code32
)
RETURNS ora2pg_project.o2p_d_code32 AS
$body$
DECLARE
  oratype ora2pg_project.o2p_d_code32 := upper(p_oratype);
BEGIN
  if oratype = 'CHAR' then
    return oratype;
  elsif oratype = 'VARCHAR2' then
    return 'VARCHAR';
  elsif oratype in ('TIMESTAMP','DATE') then
    return 'TIMESTAMPTZ';
  elsif oratype = 'NUMBER' then
    return 'NUMERIC';
  elsif oratype in ('INTEGER','BINARY_INTEGER')	then
    return 'INTEGER';
  elsif oratype = 'CLOB' then
    return 'TEXT';
  elsif oratype like 'LONG%' then
    return 'TEXT';
  elsif oratype in ('BLOB', 'LONG RAW', 'RAW') then	
    return 'BYTEA';
  elsif oratype = 'XMLTYPE' then
    return 'XML';
  elsif oratype = 'UROWID' then
    return 'OID';
  end if;
  return 'TEXT';
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_get_pgtype_4_oratype (p_oratype ora2pg_project.o2p_d_code32)
  OWNER TO ora2pg_project;