CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_is_conversion_required (
  p_po_id ora2pg_project.o2p_d_id
)
RETURNS ora2pg_project.o2p_d_ny AS
$body$
declare
 po record;
 cnt integer;
BEGIN
  select * into po from o2p_t_project_object where id=p_po_id;
  if po.po4po_id is null then
    --  
    if po.motype_code in ('TABLE','VIEW') then 
      select count(*) into cnt from o2p_t_project_object  where po4po_id=po.id and conversion_required='Y';
      if cnt>0 then
        return 'Y';
      end if;
    end if;
  end if;  
  return po.conversion_required;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_is_conversion_required (p_po_id ora2pg_project.o2p_d_id)
  OWNER TO ora2pg_project;