CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_isconvertok (
  p_acsession_id ora2pg_project.o2p_d_id,
  p_ot_code ora2pg_project.o2p_d_code32 = NULL::integer
)
RETURNS text AS
$body$
DECLARE
  r record;
  errtxt text;
  res o2p_d_code32 := 'OK';
  pattern text;
  sign text := '';
  reponly text;
BEGIN
  select errtext,report_only into errtxt,reponly from o2p_t_acsession where id=p_acsession_id;
  if reponly='Y' then return res; end if;
  if errtxt is null then return res; end if;
  /*if errtxt like '%'||chr(10)||'FATAL:%' then
    res := 'N';
    return res;
  end if;*/
  for r in (select ot_code from o2p_t_acsession_ot where acsession4acot_id=p_acsession_id) loop
    continue when p_ot_code is not null and r.ot_code!=p_ot_code;
    if r.ot_code in ('PROCEDURE','FUNCTION') then
      pattern := '% '||lower(r.ot_code)||'s (100.0\%) end of '||lower(r.ot_code)||'s export.%';
    elsif r.ot_code in ('TABLE') then
      pattern := '% '||lower(r.ot_code)||'s (100.0\%) end of '||lower(r.ot_code)||' export.%';
    elsif r.ot_code in ('SEQUENCE','TRIGGER','TYPE','VIEW','MVIEW','SYNONYM','DBLINK','PACKAGE') then
      pattern := '% '||lower(r.ot_code)||'s (100.0\%) end of output.%';
    elsif r.ot_code in ('DIRECTORY') then
      pattern := '% '||lower(r.ot_code)||' (100.0\%) end of output.%';
    elsif r.ot_code in ('USER','ROLE','TABLESPACE') then
      pattern := '%';
    else
      pattern := '%';
    end if;
    if errtxt like pattern escape '\' then
      sign := sign||'Y';
      if res='OK' then
      --res := 'OK';
      end if;
    else
      sign := sign||'N';
      res := 'ERROR';
    end if;
    exit when p_ot_code is not null and r.ot_code=p_ot_code;
  end loop;
  if p_ot_code is null then
    if sign like '%Y%' and sign not like '%N%' then return 'OK';
    elsif sign not like '%Y%' and sign like '%N%' then return 'ERROR';
    else return 'WARNING';
    end if;
  else
    return res;
  end if;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_isconvertok (p_acsession_id ora2pg_project.o2p_d_id, p_ot_code ora2pg_project.o2p_d_code32)
  OWNER TO ora2pg_project;