CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_isuseractive (
  p_project_code ora2pg_project.o2p_d_code32,
  p_username ora2pg_project.o2p_d_username = o2p_f_me(),
  p_active_date ora2pg_project.o2p_d_datetime = now()
)
RETURNS ora2pg_project.o2p_d_id AS
$body$
DECLARE
  vRetVal text;
  accdate timestamp := coalesce(p_active_date,current_timestamp);
  un text := coalesce(p_username,o2p_f_me());
BEGIN
  select min(id) into vRetval from o2p_t_user_in_project where user_username=un and project4usr_code=p_project_code
  and accdate between date_from and date_to + time '23:59:59';
  return vRetVal;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
RETURNS NULL ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_isuseractive (p_project_code ora2pg_project.o2p_d_code32, p_username ora2pg_project.o2p_d_username, p_active_date ora2pg_project.o2p_d_datetime)
  OWNER TO ora2pg_project;