CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_l2t (
  p_list ora2pg_project.o2p_d_text,
  p_delimiter ora2pg_project.o2p_d_text = ','::text
)
RETURNS TABLE (
  num ora2pg_project.o2p_d_intpos,
  value ora2pg_project.o2p_d_text
) AS
$body$
DECLARE
 dlm text := coalesce(p_delimiter,',');
 p integer;
 l text;
BEGIN --      .
 num := 0; l := p_list; value := null;
 loop
  exit when l is null;
  p := position(dlm in l);
  if coalesce(p,0)>0 then
    value := substring(l from 1 for p-1);
    l := substring(l from p+length(dlm));
  else
    value := l; l := null;
  end if;
  num := num+1;
  return next;
  end loop;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100 ROWS 1000;

ALTER FUNCTION ora2pg_project.o2p_f_l2t (p_list ora2pg_project.o2p_d_text, p_delimiter ora2pg_project.o2p_d_text)
  OWNER TO ora2pg_project;