CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_make_command4ddl (
  p_po_id ora2pg_project.o2p_d_id,
  p_acsession_id ora2pg_project.o2p_d_id
)
RETURNS text AS
$body$
DECLARE
 p record;
 cmd text;
begin

  select * into p from o2p_t_project_object where id=p_po_id;

  cmd := 
'PLPGSQL:declare
  ddl text;
  ddl_old text;
  oraddl_id o2p_d_id;
  ddl_create_date o2p_d_datetime;
  cnt numeric;
begin
  ddl := trim(leading chr(10)||'' '' from ''{JS:"{OraCLOB:(ORA)SELECT replace(replace(dbms_metadata.get_ddl(';
  
  if p.motype_code = 'MVIEW' then cmd := cmd||'''MATERIALIZED_VIEW''';
  else cmd := cmd||''''||p.motype_code||'''';
  end if;

  cmd := cmd||','''||p.name||''','''||coalesce(p.export_schema,'')||'''),'' EDITIONABLE''),''"'||coalesce(p.export_schema,'')||'".'') as ddlclob
FROM dual t WHERE '''||p.motype_code||''' not in (''GRANT'',''DIRECTORY'',''DBLINK'')
}"}'')||chr(10)||''/''||chr(10);';

  if p.motype_code in ('TABLE','VIEW','MVIEW') then
    cmd := cmd||chr(10);
	cmd := cmd||
'ddl := ddl||trim(leading chr(10)||''/'' from
''{JS:"{SQL:(ORA)SELECT ''COMMENT ON TABLE ''||table_name||'' IS ''''''||comments||''''''''||chr(10)||''/''||chr(10) as cmt from all_tab_comments
where owner='''||p.export_schema||'''
and table_name='''||p.name||'''}"}'');';
    cmd := cmd||chr(10);
	cmd := cmd||
'ddl := ddl||trim(leading chr(10) from
''{JS:"{SQL:(ORA)select ''COMMENT ON COLUMN ''||table_name||''.''||column_name||'' IS ''''''||comments||''''''''||chr(10)||''/''||chr(10) as cmt from all_col_comments
where owner='''||p.export_schema||'''
and table_name='''||p.name||'''}"}'');';
  end if;

  cmd := cmd||chr(10);
  cmd := cmd||
'insert into o2p_t_oracle_ddl (id, po4oraddl_id, acsession4oraddl_id, oracle_script, create_date)
    values (nextval(''o2p_q_oracle_ddl''), '||p.id||', '||coalesce(p_acsession_id::text,'null')||', ddl, current_timestamp)
    returning id into oraddl_id;'||chr(10);
	
if p_acsession_id is not null then	
  cmd := cmd||'select min(oracle_script), min(create_date) into ddl_old, ddl_create_date from o2p_t_oracle_ddl where id = '||coalesce(p.oraddl4po_id,'0')||';
if coalesce(ddl_old,'''') <> ddl and '''||coalesce(p.orascript_modified,'N')||''' = ''N'' then 
select count(*) into cnt from o2p_t_porevision where po4porev_id = '||p.id||' and create_date > ddl_create_date;
if cnt = 0 then'||chr(10);
end if;

  cmd := cmd||
'update o2p_t_project_object 
     set oracle_script = ddl,
         oraddl4po_id = oraddl_id,
         orascript_modified=''N'''||chr(10);
if p_acsession_id is null then
  cmd := cmd||',conversion_required=''Y'''||chr(10);
end if;
  cmd := cmd||' where id = '||p.id||';
execute o2p_f_oracle_ddl('||p.id||');';

if p_acsession_id is not null then
  cmd := cmd||chr(10)||'end if;'||chr(10)||'end if;';
end if;

  cmd := cmd||chr(10)||'end;';
  cmd := cmd||chr(10)||chr(10)||'SQL:commit;';

  return cmd;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_make_command4ddl (p_po_id ora2pg_project.o2p_d_id, p_acsession_id ora2pg_project.o2p_d_id)
  OWNER TO ora2pg_project;