CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_make_config (
  p_project_code text = NULL::text
)
RETURNS text AS
$body$
DECLARE
  cfgtxt text := '';
  grp record;
  par record;
  val text;
  aval text;
  setoff text;
  p numeric;
BEGIN
 if p_project_code is null then return null; end if;
  
 for grp in (select code from o2p_t_rf_config_group order by num) loop
    cfgtxt := cfgtxt||'#'||grp.code||chr(10);
  for par in (select code,multiple from o2p_t_rf_parameter where group4par_code=grp.code order by num) loop
     setoff := o2p_f_get_parameter_setoff(par.code,p_project_code);
     continue when setoff='Y'; --   
     
     aval := o2p_f_get_parameter_value(par.code,p_project_code);
     loop
        if par.multiple='N' then --   aval is null,    !
           val := aval; aval := null;
        else
           p := position(chr(10) in aval);
           if coalesce(p,0)=0 then
               val := aval; aval := null;
           else
               val := substring(aval from 1 for (p-1)::int);
               aval := substring(aval from (p+1)::int);
           end if;                    
        end if;        

        if val is null then --  ,     !
	       cfgtxt := cfgtxt||par.code||chr(10);
        elsif par.multiple='N' and val like '#%' then --    -   !
           null;        
        else    
           cfgtxt := cfgtxt||par.code||' '||val||chr(10);
        end if;
        exit when aval is null;  
     end loop;
  end loop;
  cfgtxt := cfgtxt||chr(10);
 end loop;
 return cfgtxt;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY DEFINER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_make_config (p_project_code text)
  OWNER TO ora2pg_project;