CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_make_oraquery (
  p_project_code text,
  p_motype_code text,
  p_po4po_id numeric = NULL::numeric
)
RETURNS text AS
$body$
DECLARE
 querystr text;
 schemalist text array;
 schemalist_ind integer;
 schemarec record;
 polist text array;
 porec record;
 parentrec record;
 nodata constant text := 'select null owner,null object_name,null comments,null object_type from dual where 1!=1';
 i integer;
 polist_ind integer;
BEGIN
 querystr := '';
 schemalist := null; i := 0; schemalist_ind := 0;
 if p_motype_code in ('USER') then
  schemalist := null; i := 0; schemalist_ind := 0;
  for schemarec in (select name from o2p_t_orasys_schema) loop
   i := i+1;
   if mod(i,1000)=1 then schemalist_ind := schemalist_ind+1; end if;
   schemalist[schemalist_ind] := coalesce(schemalist[schemalist_ind],'')||','''||schemarec.name||'''';
  end loop;
 elsif p_motype_code in ('ROLE') then
  for schemarec in (select name from o2p_t_orasys_role) loop
   i := i+1;
   if mod(i,1000)=1 then schemalist_ind := schemalist_ind+1; end if;
   schemalist[schemalist_ind] := coalesce(schemalist[schemalist_ind],'')||','''||schemarec.name||'''';
  end loop;
 else
  for schemarec in (select name from o2p_t_oracle_schema where project4oschema_code=p_project_code) loop
   i := i+1;
   if mod(i,1000)=1 then schemalist_ind := schemalist_ind+1; end if;
   schemalist[schemalist_ind] := coalesce(schemalist[schemalist_ind],'')||','''||schemarec.name||'''';
  end loop;
  if schemalist_ind=0 then
   querystr := '(ORA)select * from ('||nodata||') t';
   return querystr;
  end if;
 end if;
 for i in 1..schemalist_ind loop
  schemalist[i] := trim(leading ',' from schemalist[i]);
 end loop; 
 --
 polist := null; i := 0; polist_ind := 0;
 for porec in
 (select export_schema,name from o2p_t_project_object
  where project4obj_code=p_project_code and motype_code=p_motype_code
  and (p_motype_code in ('INDEX','TRIGGER','CONSTRAINT','FKEY') and po4po_id=p_po4po_id
  or p_motype_code not in ('INDEX','TRIGGER','CONSTRAINT','FKEY') and po4po_id is null)
  )
 loop
  i := i+1;
  if mod(i,1000)=1 then polist_ind := polist_ind+1; end if;
   polist[polist_ind] := coalesce(polist[polist_ind],'')||','''||
  case when coalesce(porec.export_schema,'')='' then '' else porec.export_schema||'.' end||
  porec.name||'''';
 end loop;
 for i in 1..polist_ind loop
  polist[i] := trim(leading ',' from polist[i]);
 end loop;
 -- 
 if p_motype_code in ('TABLE','VIEW','MVIEW') then
  querystr := querystr||chr(10)||
  'select t1.owner,t1.object_name,ltrim(decode(t1.temporary,''Y'',''TEMPORARY'',null)||'||
  ''',''||t2.comments,'','') comments, t1.object_type'||chr(10)||
  'from all_objects t1, all_tab_comments t2'||chr(10)||
  'where t1.object_type='''||
  case when P_MOTYPE_CODE='MVIEW' then 'MATERIALIZED VIEW' else P_MOTYPE_CODE end||''''||chr(10)||
  'and t2.owner(+)=t1.owner and t2.table_name(+)=t1.object_name';
  for i in 1..schemalist_ind loop
    querystr := querystr||chr(10)|| 'and t1.owner in ('||schemalist[i]||')';
  end loop;
  for i in 1..polist_ind loop
    querystr := querystr||chr(10)|| 'and t1.owner||''.''||object_name not in ('||polist[i]||')';
  end loop;
 --
 elsif p_motype_code in ('PROCEDURE','FUNCTION','PACKAGE') then
  querystr := querystr||chr(10)||
  'select t1.owner,t1.object_name, null comments, t1.object_type'||chr(10)||
  'from all_objects t1'||chr(10)||
  'where t1.object_type='''||P_MOTYPE_CODE||'''';
  for i in 1..schemalist_ind loop
    querystr := querystr||chr(10)||'and t1.owner in ('||schemalist[i]||')';
  end loop;
  for i in 1..polist_ind loop
    querystr := querystr||chr(10)|| 'and t1.owner||''.''||object_name not in ('||polist[i]||')';
  end loop;
 -- 
 elsif p_motype_code in ('TABLESPACE') then
  querystr := querystr||chr(10)||
  'select distinct null owner,tablespace_name object_name,null comments,'||chr(10)||
  '''TABLESPACE'' object_type from all_tables'||chr(10)||
  'where tablespace_name>'' '' and owner in ('||schemalist||')'||
  case when polist_ind=0 then '' else
  chr(10)||'and tablespace_name not in ('||polist[1]||')' end||
  'union'||chr(10)||
  'select distinct null,tablespace_name,null,''TABLESPACE'' from all_indexes'||chr(10)||
  'where tablespace_name>'' '' and owner in ('||schemalist||')'||
  case when polist_ind=0 then '' else
  chr(10)||'and tablespace_name not in ('||polist[1]||')' end||
  'union'||chr(10)||
  'select distinct null,tablespace_name,null,''TABLESPACE'' from all_tab_partitions'||chr(10)||
  'where table_owner in ('||schemalist||')'||
  case when polist_ind=0 then '' else
  chr(10)||'and tablespace_name not in ('||polist[1]||')' end||
  'union'||chr(10)||
  'select distinct null,tablespace_name,null,''TABLESPACE'' from all_ind_partitions'||chr(10)||
  'where index_owner in ('||schemalist||')'||
  case when polist_ind=0 then '' else
  chr(10)||'and tablespace_name not in ('||polist[1]||')' end||
  'union'||chr(10)||
  'select distinct null,t1.tablespace_name,null,''TABLESPACE'''||chr(10)||
  'from all_lobs t1, all_tables t2'||chr(10)||
  'where t2.owner=t1.owner and t2.table_name=t1.table_name and t2.temporary=''N'''||chr(10)||
  'and t1.owner in ('||schemalist||')'||
  case when polist_ind=0 then '' else
  chr(10)||'and t1.tablespace_name not in ('||polist[1]||')' end;
 --
 elsif p_motype_code in ('DBLINK') then
  querystr := querystr||chr(10)||
  'select owner,db_link object_name,username||decode(host,null,null,''@''||host) comments,''DBLINK'' object_type'||
  ' from all_db_links'||chr(10)||'where';
  for i in 1..schemalist_ind loop
    if i>1 then querystr := querystr||chr(10)||'and'; end if;
    querystr := querystr||' owner in ('||schemalist[i]||')';
  end loop;
  for i in 1..polist_ind loop
    querystr := querystr||chr(10)||'and owner||''.''||db_link not in ('||polist[i]||')';
  end loop;
 --
 elsif p_motype_code in ('INDEX') then
  for parentrec in (select export_schema,name from o2p_t_project_object where id=P_PO4PO_ID) loop
   querystr := querystr||chr(10)||
   'select owner,index_name object_name,null comments,''INDEX'' object_type from all_indexes'||chr(10)||
   'where table_owner='''||parentrec.export_schema||''' and table_name='''||parentrec.name||'''';
   for i in 1..schemalist_ind loop
    querystr := querystr||chr(10)||'and owner in ('||schemalist[i]||')';
   end loop;
   for i in 1..polist_ind loop
    querystr := querystr||chr(10)||'and owner||''.''||index_name not in ('||polist[i]||')';
   end loop;
  end loop;
 --
 elsif p_motype_code in ('TRIGGER') then
  for parentrec in (select export_schema,name from o2p_t_project_object where id=P_PO4PO_ID) loop
   querystr := querystr||chr(10)||
   'select owner,trigger_name object_name,null comments,''TRIGGER'' object_type from all_triggers'||chr(10)||
   'where table_owner='''||parentrec.export_schema||''' and table_name='''||parentrec.name||'''';
   for i in 1..schemalist_ind loop
    querystr := querystr||chr(10)||'and owner in ('||schemalist[i]||')';
   end loop;
   for i in 1..polist_ind loop
    querystr := querystr||chr(10)||'and owner||''.''||trigger_name not in ('||polist[i]||')';
   end loop;
  end loop;
 --
 elsif p_motype_code in ('CONSTRAINT') then
  for parentrec in (select export_schema,name from o2p_t_project_object where id=P_PO4PO_ID) loop
   querystr := querystr||chr(10)||
   'select owner,constraint_name object_name,search_condition_vc comments,''CONSTRAINT'' object_type'||chr(10)||
   'from all_constraints'||chr(10)||
   'where constraint_type in (''U'',''P'',''C'') and constraint_name not like ''SYS%'''||chr(10)||
   'and owner='''||parentrec.export_schema||''' and table_name='''||parentrec.name||'''';
   for i in 1..schemalist_ind loop
    querystr := querystr||chr(10)||'and owner in ('||schemalist[i]||')';
   end loop;
   for i in 1..polist_ind loop
    querystr := querystr||chr(10)||'and owner||''.''||constraint_name not in ('||polist[i]||')';
   end loop;
  end loop;
 --
 elsif p_motype_code in ('FKEY') then
  for parentrec in (select export_schema,name from o2p_t_project_object where id=P_PO4PO_ID) loop
   querystr := querystr||chr(10)||
   'select t1.owner,t1.constraint_name object_name,t2.table_name comments,''FKEY'' object_type'||chr(10)||
   'from all_constraints t1,all_constraints t2'||chr(10)||
   'where t1.constraint_type=''R'''||chr(10)||
   'and t2.constraint_name=t1.r_constraint_name'||chr(10)||
   'and t2.owner=t1.r_owner'||chr(10)||
   'and t1.owner='''||parentrec.export_schema||''' and t1.table_name='''||parentrec.name||'''';
   for i in 1..schemalist_ind loop
    querystr := querystr||chr(10)||'and t1.owner in ('||schemalist[i]||')';
   end loop;
   for i in 1..polist_ind loop
    querystr := querystr||chr(10)||'and t1.owner||''.''||t1.constraint_name not in ('||polist[i]||')';
   end loop;
  end loop;
 --
 elsif p_motype_code in ('DIRECTORY') then
  querystr := querystr||chr(10)||
  'select null owner,directory_name object_name,directory_path comments,''DIRECTORY'' object_type from all_directories';
  if polist_ind>0 then
   querystr := querystr||chr(10)||'where';
   for i in 1..polist_ind loop
    if i>1 then querystr := querystr||chr(10)||'and'; end if;
    querystr := querystr||' directory_name not in ('||polist[i]||')';
   end loop;
  end if;
 -- 
 elsif p_motype_code in ('USER') then
  querystr := querystr||chr(10)||
  'select null owner,username object_name, null comments, ''USER'' object_type'||chr(10)||
  'from all_users'||chr(10)||'where';
  for i in 1..schemalist_ind loop
   if i>1 then querystr := querystr||chr(10)||'and'; end if;
   querystr := querystr||' username not in ('||schemalist[i]||')';
  end loop;
  for i in 1..polist_ind loop
   querystr := querystr||chr(10)||'and username not in ('||polist[i]||')';
  end loop;
  -- 
 elsif p_motype_code in ('ROLE') then  
  querystr := querystr||chr(10)||
  'select null owner,t1.role object_name,'||
  'decode(password_required,''YES'',''PASSWORD_REQUIRED'') comments,'||
  '''ROLE'' object_type'||chr(10)||
  'from dba_roles t1'||chr(10)||'where';
  for i in 1..schemalist_ind loop
   if i>1 then querystr := querystr||chr(10)||'and'; end if;
   querystr := querystr||' role not in ('||schemalist[i]||')';
  end loop;
  for i in 1..polist_ind loop
   querystr := querystr||chr(10)||'and role not in ('||polist[i]||')';
  end loop;
 --  
 elsif p_motype_code in ('SYNONYM') then
  querystr := querystr||chr(10)||
  'select t1.owner,t1.synonym_name object_name,'||
  't1.table_owner||''.''||t1.table_name||'||
  '''(''||decode(t2.object_type,''MATERIALIZED VIEW'',''MVIEW'',t2.object_type)||'')'' comments,'||
  '''SYNONYM'' object_type'||chr(10)||
  'from all_synonyms t1,all_objects t2'||chr(10)||
  'where t1.db_link is null'||chr(10)||
  'and t2.owner=t1.table_owner'||chr(10)||
  'and t2.object_name=t1.table_name'||chr(10)||
  'and t2.object_type not like ''%BODY%''';
  for i in 1..schemalist_ind loop
   querystr := querystr||chr(10)||'and t1.owner in ('||schemalist[i]||')';
  end loop;
  for i in 1..polist_ind loop
   querystr := querystr||chr(10)||'and t1.owner||''.''||t1.synonym_name not in ('||polist[i]||')';
  end loop;
  querystr := querystr||chr(10)||'union all'||chr(10)||
  'select t1.owner,t1.synonym_name,t1.table_owner||''.''||t1.table_name||''@''||t1.db_link||''(UNKNOWN)'','||
  '''SYNONYM'''||chr(10)||
  'from all_synonyms t1 where t1.db_link>'' ''';
  for i in 1..schemalist_ind loop
   querystr := querystr||chr(10)||'and t1.owner in ('||schemalist[i]||')';
  end loop;
  for i in 1..polist_ind loop
   querystr := querystr||chr(10)||'and t1.owner||''.''||t1.synonym_name not in ('||polist[i]||')';
  end loop;
 -- 
 elsif p_motype_code in ('TYPE') then
  querystr := querystr||chr(10)||
  'select owner,type_name object_name,typecode comments,''TYPE'' object_type from all_types'||chr(10)||'where';
  for i in 1..schemalist_ind loop
   if i>1 then querystr := querystr||chr(10)||'and'; end if;
   querystr := querystr||' owner in ('||schemalist[i]||')';
  end loop;
  for i in 1..polist_ind loop
   querystr := querystr||chr(10)||'and owner||''.''||type_name not in ('||polist[i]||')';
  end loop;
 --
 elsif p_motype_code in ('SEQUENCE') then
  querystr := querystr||chr(10)||
  'select t1.owner,t1.object_name,null comments, t1.object_type'||chr(10)||
  'from all_objects t1'||chr(10)||
  'where t1.object_type='''||P_MOTYPE_CODE||'''';
  for i in 1..schemalist_ind loop
   querystr := querystr||chr(10)||'and t1.owner in ('||schemalist[i]||')';
  end loop;
  for i in 1..polist_ind loop
   querystr := querystr||chr(10)||'and t1.owner||''.''||t1.object_name not in ('||polist[i]||')';
  end loop;
 end if;
 --
 if length(querystr)>0 then
  querystr := '(ORA)select * from ('||querystr||chr(10)||') t';
 else
  querystr := '(ORA)select * from ('||nodata||') t';
 end if;
 --
 return querystr;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_make_oraquery (p_project_code text, p_motype_code text, p_po4po_id numeric)
  OWNER TO ora2pg_project;