CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_make_pg_script_4_step (
  p_step_id numeric
)
RETURNS text AS
$body$
DECLARE
  obj record;
  res text := '';
  steptype text := '';
BEGIN
  select min(steptype_code) into steptype from o2p_t_step where id = p_step_id;
  if steptype = 'STORED_DATA' then
    res := 'SET client_encoding TO ''UTF8'';'||chr(10);
    res := res||'\set ON_ERROR_STOP ON'||chr(10);
    for obj in
	   (select o.*, f.path, f.filename
	      from o2p_t_step s
		  join o2p_t_object o on o.step4o_id = s.id
		  join o2p_t_file f on f.id = o.file4o_id
		 where s.id = p_step_id 
	       and o.ostatus4o_code = 'READY'
		 order by o.num)
	loop	  
      if res > ' ' then res := res||chr(10); end if;
      res := res||'SET search_path TO '||obj.postgres_schema||';'||chr(10);
	  res := res||'\i '||obj.path||'/'||obj.filename;
	end loop;  
  else
    for obj in 
       (select o.*, s.project4step_code project_code, s.steptype_code, lt.textdata pgscript_data 
	      from o2p_t_step s
  		  join o2p_t_object o on o.step4o_id = s.id
		  left join o2p_t_long_text lt on lt.id = o.pgscript_id
	     where s.id = p_step_id 
	       and o.ostatus4o_code = 'READY' 
	     order by o.num)
    loop
      if res > ' ' then res := res||chr(10)||chr(10); end if;
	  if obj.postgres_schema is not null and obj.pgtype4o_code not in ('TABLESPACE', 'SCHEMA') then
	    res := res||'set search_path to '||obj.postgres_schema||';'||chr(10)||chr(10);
	  end if;
	  res := res||obj.postgres_script;
    end loop;
  end if;
  return res;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_make_pg_script_4_step (p_step_id numeric)
  OWNER TO ora2pg_project;