CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_make_tab_attr_4_config (
  p_acsession_id numeric,
  p_attr_code text
)
RETURNS text AS
$body$
DECLARE
  str text := '';
  res text := '';
  pobj record;
  tabcol record;
BEGIN
  --       
  for pobj in 
      (select po.*, s.steptype_code 
	     from o2p_t_object o 
	     join o2p_t_object4projectobject opo on opo.o4opo_id = o.id
	     join o2p_t_project_object po on po.id = opo.po4opo_id
		 join o2p_t_acsession_object ao on ao.o4acso_id = o.id
	     left join o2p_t_step s on s.id = o.step4o_id
	    where ao.acsession4acso_id = p_acsession_id
		union all
	   select po.*, null::text
	     from o2p_t_po2acsession po4as
		 join o2p_t_project_object po on po.id = po4as.po4acsession_id
		where po4as.acsession4po_id = p_acsession_id)
--  for pobj in 
--      (select po.*, s.steptype_code 
--	     from o2p_t_object o 
--	     join o2p_t_object4projectobject opo on opo.o4opo_id = o.id
--	     join o2p_t_project_object po on po.id = opo.po4opo_id
--		 join o2p_t_acsession_object ao on ao.o4acso_id = o.id
--	     left join o2p_t_step s on s.id = o.step4o_id
--	    where ao.acsession4acso_id = p_acsession_id)
  loop
      -- 1.       
      if p_attr_code = 'MODIFY_STRUCT' then
	    str := '';
	    for tabcol in (select * from o2p_t_tab_column where po4tabcol_id = pobj.id)
		loop	
	      if str > ' ' then str := str||','; end if;
	      str := str||lower(tabcol.src_col_name);
		end loop;
		if str > ' ' then
		  if res > ' ' then res := res||' '; end if;
		  res := res||pobj.name||'('||str||')';
		end if;
  
      -- 2.      	
      elsif p_attr_code = 'REPLACE_TABLES' then
	    if pobj.name != coalesce(pobj.dst_tab_name,pobj.name) then
	      if res > ' ' then res := res||' '; end if;
	      res := res||pobj.name||':'||pobj.dst_tab_name;
		end if;  
  
      -- 3.       	
      elsif p_attr_code = 'REPLACE_COLS' then
        str := '';
	    for tabcol in (select * from o2p_t_tab_column where po4tabcol_id = pobj.id and src_col_name != dst_colname)
		loop	
	      if str > ' ' then str := str||','; end if;
	      str := str||tabcol.src_col_name||':'||tabcol.dst_colname;
		end loop;
		if str > ' ' then
  	      if res > ' ' then res := res||' '; end if;
	      res := res||pobj.name||'('||str||')';
		end if;  
  
      -- 4.      ,        ora2pg
      elsif p_attr_code = 'MODIFY_TYPE' then
	    for tabcol in (select * from o2p_t_tab_column where po4tabcol_id = pobj.id)
		loop	
	      if res > ' ' then res := res||','; end if;
	      res := res||pobj.name||':'||tabcol.src_col_name||':'||lower(tabcol.dst_col_datatype);
		  if tabcol.dst_datatype_maxlen is not null then
		    res := res||'('||tabcol.dst_datatype_maxlen;
		    if tabcol.dst_datatype_declen is not null then
			  res := res||'\,'||tabcol.dst_datatype_declen;
			end if;
			res := res||')';
		  end if;
		end loop;  
  
      -- 5.         - 
      elsif p_attr_code = 'WHERE' and pobj.steptype_code = 'STORED_DATA' then
	    if pobj.where_clause > ' ' then
		  if res > ' ' then res := res||' '; end if;
		  res := res||pobj.name||'['||pobj.where_clause||']';
--		  res := res||pobj.name||'['||replace(pobj.where_clause,'''','''''')||']';
		end if;
  
      -- 6.        
      elsif p_attr_code = 'ALLOW' then
	    if pobj.motype_code = 'TABLE' then
		  if res > ' ' then res := res||' '; end if;
		  res := res||replace(pobj.name,'$','.*');
		end if;
		
      end if;
  end loop;

  if p_attr_code = 'ALLOW' and res > ' ' then
    res := 'TABLE['||res||']';
  end if;	

  return res;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_make_tab_attr_4_config (p_acsession_id numeric, p_attr_code text)
  OWNER TO ora2pg_project;