CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_oracle_ddl (
  p_po_id ora2pg_project.o2p_d_id
)
RETURNS void AS
$body$
DECLARE
 porec record;
 l text;
 constxt text;
 p numeric;
 neworascript text;
 cons boolean;
 childrec record;
BEGIN
--return;
 select * into porec from o2p_t_project_object where id=p_po_id;
 if porec.motype_code='TABLE' then
  neworascript := ''; 
  --     
  cons := false;
  loop
   exit when coalesce(porec.oracle_script,'')='';
   p := position(chr(10) in porec.oracle_script);
   if p=0 then l := porec.oracle_script; p := length(porec.oracle_script)+1;
   else l := substring(porec.oracle_script,1,(p-1)::integer);
   end if;
   if l like '%CONSTRAINT%PRIMARY%KEY%' then
	constxt := l; cons := true;
   --
   elsif l like '%CONSTRAINT%UNIQUE%' then
    constxt := l; cons := true;
   --
   elsif l like '%CONSTRAINT%CHECK%' then
    constxt := l;  cons := true; --   check-
    if l like '%ENABLE%' or l like '%DISABLE%' then
     -- Check-  
     cons := false;
     for childrec in (select id,name from o2p_t_project_object
      where po4po_id=porec.id and motype_code='CONSTRAINT')
     loop
      if constxt like '% "'||childrec.name||'" %' then
       constxt := trim(leading ' ' from constxt);
       constxt := 'ALTER TABLE '||porec.name||' ADD'||constxt;
       constxt := trim(trailing ', '||chr(10) from constxt)||chr(10)||'/'||chr(10);
       update o2p_t_project_object set oracle_script=constxt where id=childrec.id;
       exit;
      end if;
     end loop;
    end if;
   --
   elsif l like '%CONSTRAINT%FOREIGN%KEY%' then
    --     
    constxt := l; cons := true;
   --
   elsif l like '%REFERENCES%' and cons then
    --   
    constxt := constxt||chr(10)||l;  cons := false;
    for childrec in (select id,name from o2p_t_project_object where po4po_id=porec.id and motype_code='FKEY') loop
     if constxt like '% "'||childrec.name||'" %' then
      constxt := 'ALTER TABLE '||porec.name||' ADD'||constxt;
      constxt := trim(trailing ', '||chr(10) from constxt)||chr(10)||'/'||chr(10);
      update o2p_t_project_object set oracle_script=constxt where id=childrec.id;
      exit;
     end if;
    end loop;
   --
   elsif l like '%USING INDEX%' and cons then
    --      
    --constxt := constxt||chr(10)||l;
    if l like '%PCTFREE%' then null; --      
    elsif l like '%CREATE INDEX%' then
	 constxt := constxt||chr(10)||' USING INDEX '||substring(l,(length('  USING INDEX (CREATE INDEX ')+1)::integer,
     position(' ON ' in l)-1-length('  USING INDEX (CREATE INDEX '));
    end if;
   elsif l like '%PCTFREE%' and cons then
    --      
    --constxt := constxt||chr(10)||l;
    null;
   --
   elsif l like '%STORAGE%' and cons then
    --      
    --constxt := constxt||chr(10)||l;
    null;
   --
   elsif l like '%PCTINCREASE%'and cons then
    --      
    --constxt := constxt||chr(10)||l;
    null;
   --
   elsif l like '%BUFFER_POOL%'and cons then
    --      
    --constxt := constxt||chr(10)||l;
    null;
   --
   elsif l like '%TABLESPACE%' and cons then
    --     
    constxt := constxt||chr(10)||
    case when l like '%ENABLE%' then 'ENABLE' else 'DISABLE' end; cons := false;
    for childrec in (select id,name from o2p_t_project_object
     where po4po_id=porec.id and motype_code='CONSTRAINT')
    loop
     if constxt like '% "'||childrec.name||'" %' then
      constxt := trim(leading ' ' from constxt);
      constxt := 'ALTER TABLE '||porec.name||' ADD'||constxt;
      constxt := trim(trailing ', '||chr(10) from constxt)||chr(10)||'/'||chr(10);
      update o2p_t_project_object set oracle_script=constxt where id=childrec.id;
      exit;
     end if;
    end loop;
   --
   elsif l not like '%ENABLE%' and l not like '%DISABLE%' and
    cons=true and constxt like '% CHECK %' then
    --   check-
    constxt := constxt||chr(10)||l;
   --
   elsif (l like '%ENABLE%' or l like '%DISABLE%') and cons=true and constxt like '% CHECK %' then
    -- Check- 
    cons := false;
    constxt := constxt||chr(10)||l;
    for childrec in (select id,name from o2p_t_project_object
     where po4po_id=porec.id and motype_code='CONSTRAINT')
    loop
     if constxt like '% "'||childrec.name||'" %' then
      constxt := trim(leading ' ' from constxt);
      constxt := 'ALTER TABLE '||porec.name||' ADD'||constxt;
      constxt := trim(trailing ', '||chr(10) from constxt)||chr(10)||'/'||chr(10);
      update o2p_t_project_object set oracle_script=constxt where id=childrec.id;
      exit;
     end if;
    end loop;
   --
   else
    constxt := ''; cons := false;
    neworascript := neworascript||chr(10)||l;
   end if;
   porec.oracle_script := substring(porec.oracle_script,(p+1)::integer);
  end loop;
  neworascript := neworascript||chr(10);
--
elsif porec.motype_code='PACKAGE' then
  neworascript := '';
  loop
   exit when coalesce(porec.oracle_script,'')='';
   p := position(chr(10) in porec.oracle_script);
   if p=0 then l := porec.oracle_script; p := length(porec.oracle_script)+1;
   else l := substring(porec.oracle_script,1,(p-1)::integer);
   end if;
   if upper(l) like '%BODY%' then
    neworascript := neworascript||'/'||chr(10);
   end if;
   neworascript := neworascript||l||chr(10);
   porec.oracle_script := substring(porec.oracle_script,(p+1)::integer);
  end loop;
  elsif porec.motype_code='TYPE' then
  neworascript := '';
  loop
   exit when coalesce(porec.oracle_script,'')='';
   p := position(chr(10) in porec.oracle_script);
   if p=0 then l := porec.oracle_script; p := length(porec.oracle_script)+1;
   else l := substring(porec.oracle_script,1,(p-1)::integer);
   end if;
   if upper(l) like '%BODY%' then
    neworascript := trim(trailing chr(10)||' ' from neworascript)||chr(10)||'/'||chr(10);
   end if;
   neworascript := neworascript||l||chr(10);
   porec.oracle_script := substring(porec.oracle_script,(p+1)::integer);
  end loop;
 --
 elsif porec.motype_code='TRIGGER' then
  neworascript := '';
  loop
   exit when coalesce(porec.oracle_script,'')='';
   p := position(chr(10) in porec.oracle_script);
   if p=0 then l := porec.oracle_script; p := length(porec.oracle_script)+1;
   else l := substring(porec.oracle_script,1,(p-1)::integer);
   end if;
   if upper(l) like '%ALTER%' then
    neworascript := trim(trailing chr(10)||' ' from neworascript)||chr(10)||'/'||chr(10);
   end if;
   neworascript := neworascript||l||chr(10);
   porec.oracle_script := substring(porec.oracle_script,(p+1)::integer);
  end loop;
 --
 elsif porec.motype_code='TABLESPACE' then
  neworascript := '';
  loop
   exit when coalesce(porec.oracle_script,'')='';
   p := position(chr(10) in porec.oracle_script);
   if p=0 then l := porec.oracle_script; p := length(porec.oracle_script)+1;
   else l := substring(porec.oracle_script,1,(p-1)::integer);
   end if;
   if upper(l) like '%ALTER%' then
    l := trim(leading ' ' from l);
    neworascript := trim(trailing chr(10)||' ' from neworascript)||chr(10)||'/'||chr(10);
   end if;
   neworascript := neworascript||l||chr(10);
   porec.oracle_script := substring(porec.oracle_script,(p+1)::integer);
  end loop;
 --
 elsif porec.motype_code='DIRECTORY' then
  neworascript := 'CREATE OR REPLACE DIRECTORY '||porec.name||' AS ''/usr/bin/bfile_dir'''||chr(10)||'/';
 --
 elsif porec.motype_code='DBLINK' then
  neworascript := 'CREATE';
  if porec.export_schema='PUBLIC' then neworascript := neworascript||' PUBLIC'; end if;
  neworascript := neworascript||' DATABASE LINK '||porec.name;
  if coalesce(porec.comment,'')!='' then
   if porec.comment like '%@%' then
    p := position('@' in porec.comment);
    if p=1 then l :=''; else l := substring(porec.comment,1,(p-1)::integer); end if;
    if l!='' then
     neworascript := neworascript||chr(10)||' CONNECT TO '||l||' IDENTIFIED BY pwd';
    end if;
    l := substring(porec.comment,(p+1)::integer);
    neworascript := neworascript||chr(10)||' USING '''||l||'''';
   else
    neworascript := neworascript||chr(10)||' CONNECT TO '||porec.comment||' IDENTIFIED BY pwd';
   end if;
  end if; 
  neworascript := neworascript||chr(10)||'/';
 --
 else
  neworascript := porec.oracle_script;
 end if;
 neworascript := trim(leading chr(10)||' ' from neworascript);
 neworascript := trim(trailing chr(10) from neworascript)||chr(10);
 neworascript := regexp_replace(neworascript,',[\s]*\)',')','g');
 update o2p_t_project_object set oracle_script=neworascript where id=p_po_id;
 return;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_oracle_ddl (p_po_id ora2pg_project.o2p_d_id)
  OWNER TO ora2pg_project;