CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_ostatus (
  p_object_id ora2pg_project.o2p_d_id
)
RETURNS ora2pg_project.o2p_d_text AS
$body$
DECLARE
  --         .
  orec record;
  res o2p_d_text;
BEGIN
  res := '';
  if p_object_id is null then return 'NEW:NEW;'; end if;
  
  for orec in (select * from o2p_t_object where id=p_object_id) loop
    if orec.ostatus4o_code='NEW' then
        res := 'WORK:WORK;READY:READY;CANCELLED:CANCELLED;';
    elsif orec.ostatus4o_code='WORK' then
        res := 'READY:READY;CANCELLED:CANCELLED;';
    elsif orec.ostatus4o_code='READY' then
	    res := 'WORK:WORK;CANCELLED:CANCELLED;';
    elsif orec.ostatus4o_code='CANCELLED' then 
	    res := 'WORK:WORK;READY:READY;';    
    end if;
  end loop;
  
  return res;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_ostatus (p_object_id ora2pg_project.o2p_d_id)
  OWNER TO ora2pg_project;