CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_rf_export (
  p_rf_table text
)
RETURNS SETOF text AS
$body$
declare
 tcur record;
 colcur record;
 rowcur refcursor;
 colstr text;
 valstr text;
 str text;
 s text;
begin
 for tcur in (
  select table_name,
        (SELECT count(*) --        
         FROM information_schema.table_constraints AS tc
         WHERE tc.constraint_type = 'FOREIGN KEY' AND tc.table_name=t1.table_name
        ) n
  from information_schema.tables t1
  where table_schema='ora2pg_project' and (p_rf_table is null and lower(table_name) like 'o2p_t_rf%'
  or p_rf_table is not null and lower(table_name)=lower(p_rf_table))
  order by n,table_name)
 loop
  colstr := '';
  valstr := '';
  for colcur in (select column_name 
	from information_schema.columns 
	where table_schema='ora2pg_project' and table_name like 'o2p_t_rf%'
	and table_name=tcur.table_name
    order by ordinal_position)
  loop
    colstr := colstr||', '||colcur.column_name;
    --valstr := valstr||',''''''||coalesce('||colcur.column_name||'::text,'''')||''''''';
    valstr := valstr||',''||coalesce(quote_literal('||colcur.column_name||'::text),''null'')||''';
  end loop;
  colstr := ltrim(colstr,',');
  valstr := ltrim(valstr,',');
  valstr := ''''||valstr||'''';
  str := 'insert into '||tcur.table_name||'('||colstr||')'||chr(10)||
  'values (valstr);';
  s := 'SELECT '||valstr||' FROM '||tcur.table_name;
  open rowcur for EXECUTE s;
  loop
   fetch rowcur into valstr;
   exit when not found;
   valstr := replace(str,'valstr',valstr);
   return next valstr;
  end loop;
  close rowcur;
  return next chr(10);
 end loop;
end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100 ROWS 1000;

ALTER FUNCTION ora2pg_project.o2p_f_rf_export (p_rf_table text)
  OWNER TO ora2pg_project;