CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_save_user_in_project (
  p_id ora2pg_project.o2p_d_id,
  p_username ora2pg_project.o2p_d_name,
  p_project_code ora2pg_project.o2p_d_code32,
  p_is_leader ora2pg_project.o2p_d_ny,
  p_date_from ora2pg_project.o2p_d_date,
  p_date_to ora2pg_project.o2p_d_date = o2p_f_get_defhist_to()
)
RETURNS ora2pg_project.o2p_d_text AS
$body$
DECLARE
  uip record;
  cnt o2p_d_number;
  d_date_to o2p_d_date := p_date_to;
BEGIN
  if d_date_to is null then d_date_to := o2p_f_get_defhist_to()::o2p_d_date; end if;
  -- 1. ,        ,        p_date_from  d_date_to
  for uip in
      (select *
         from o2p_t_user_in_project
	    where user_username = p_username
		  and project4usr_code = p_project_code
	      and date_from <= d_date_to
   	      and date_to >= p_date_from
		  and (id != p_id or p_id is null))
  loop
    --                 
    return 'ShowMessage:O2P-00004;p1:'||p_username||
	  ';p2:'||to_char(p_date_from,'DD.MM.YYYY HH24:MI:SS')||';p3:'||to_char(d_date_to,'DD.MM.YYYY HH24:MI:SS')||
	  ';p4:'||to_char(uip.date_from,'DD.MM.YYYY HH24:MI:SS')||';p5:'||to_char(uip.date_to,'DD.MM.YYYY HH24:MI:SS')||';';
  end loop;

  -- 2.      (), ,         ,   
  --     p_date_from  d_date_to
  if p_is_leader = 'Y' then
    for uip in
        (select *
           from o2p_t_user_in_project
	      where user_username != p_username
  		    and project4usr_code = p_project_code
			and is_leader = 'Y'
	        and date_from <= d_date_to
   	        and date_to >= p_date_from)
    loop
      --         ()       
      return 'ShowMessage:O2P-00005;p1:'||p_project_code||
	    ';p2:'||to_char(greatest(p_date_from,uip.date_from),'DD.MM.YYYY HH24:MI:SS')||';p3:'||to_char(least(d_date_to,uip.date_to),'DD.MM.YYYY HH24:MI:SS')||';';
    end loop;
  end if;

  -- 3.      
  if p_id is null then
    insert into o2p_t_user_in_project (user_username, project4usr_code, is_leader, date_from, date_to)
	  values (p_username, p_project_code, p_is_leader, p_date_from, d_date_to);
  else
    -- ,      user_username, project4usr_code, is_leader   .
	--  is_leader          .
	update o2p_t_user_in_project
	   set is_leader = p_is_leader,
	       date_from = p_date_from,
	       date_to = d_date_to
	 where id = p_id;
  end if;
  return '';
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_save_user_in_project (p_id ora2pg_project.o2p_d_id, p_username ora2pg_project.o2p_d_name, p_project_code ora2pg_project.o2p_d_code32, p_is_leader ora2pg_project.o2p_d_ny, p_date_from ora2pg_project.o2p_d_date, p_date_to ora2pg_project.o2p_d_date)
  OWNER TO ora2pg_project;