CREATE OR REPLACE FUNCTION ora2pg_project.o2p_f_set_parameter_value (
  p_parameter_code ora2pg_project.o2p_d_code32,
  p_value ora2pg_project.o2p_d_text,
  p_setoff ora2pg_project.o2p_d_ny = 'N'::character varying,
  p_project_code ora2pg_project.o2p_d_code32 = NULL::character varying
)
RETURNS ora2pg_project.o2p_d_id AS
$body$
declare
setoff o2p_d_ny := coalesce(p_setoff,'N');
vid numeric;
begin
 if p_parameter_code is null then return null; end if;
 
 if p_project_code is null then
  vid := -1;
 else
  select min(id) into vid from o2p_t_parameter_value t where t.project4parval_code=p_project_code and t.par4val_code=p_parameter_code;
 end if;
 
 if vid is null then
  insert into o2p_t_parameter_value(id,par4val_code,parvalue,project4parval_code,set_off)
  values (nextval('o2p_q_parameter_value'),p_parameter_code,p_value,P_PROJECT_CODE,setoff)
  returning id into vid;
 elsif vid=-1 then
  update o2p_t_rf_parameter set default_value=p_value,initially_off=setoff where code=p_parameter_code;
 else
  update o2p_t_parameter_value set parvalue=p_value,set_off=setoff where id=vid;
 end if;
 
 if P_PROJECT_CODE is not null then
  update o2p_t_project set config=o2p_f_make_config(P_PROJECT_CODE)
  where code=P_PROJECT_CODE;
 end if;
 
 return vid;
end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_f_set_parameter_value (p_parameter_code ora2pg_project.o2p_d_code32, p_value ora2pg_project.o2p_d_text, p_setoff ora2pg_project.o2p_d_ny, p_project_code ora2pg_project.o2p_d_code32)
  OWNER TO ora2pg_project;