CREATE OR REPLACE FUNCTION ora2pg_project.o2p_r_create_pgobjects (
  p_acsession_id numeric
)
RETURNS void AS
$body1$
DECLARE
 prjcode text;
 oschema text;
 frec record;
 porec record;
 otrec record;
 fline record;
 pgoid numeric;
 l text;
 p numeric;
 pgtext text;
 polist o2p_t_project_object[];
 po4grantlist o2p_t_project_object[];
 o o2p_t_object;
 olist o2p_t_object[];
 i numeric;
 j numeric;
 k numeric;
 linenumber numeric;
 p1 integer;
 p2 integer;
 str text;
BEGIN
 select project4acsession_code,oschema4acsession_name
 into prjcode,oschema from o2p_t_acsession where id=p_acsession_id;
 for otrec in (select * from o2p_t_acsession_ot where acsession4acot_id=p_acsession_id) loop
  for frec in (select * from o2p_t_file t1 where acsessionot4file_id=otrec.id order by num) loop
   if otrec.ot_code='MVIEW' then
    continue when frec.filename='mview.sql';
    for porec in (select * from o2p_t_project_object
     where project4obj_code=prjcode and motype_code=otrec.ot_code
     and coalesce(export_schema,'')=coalesce(oschema,'')
     and frec.filename=name||'_mview.sql')
    loop
     insert into o2p_t_object(id,postgres_script,ostatus4o_code,
     postgres_schema,acsession4o_id,name,pgtype4o_code)
     values (nextval('o2p_q_object'),frec.filedata,'AUTO',oschema,
     p_acsession_id,porec.name,otrec.ot_code) returning id into pgoid;
     insert into o2p_t_object4projectobject
     (id,po4opo_id,o4opo_id) values
     (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
    end loop;
    --
   elsif otrec.ot_code='VIEW' then
    continue when frec.filename='view.sql';
    for porec in (select * from o2p_t_project_object
     where project4obj_code=prjcode and motype_code=otrec.ot_code
     and coalesce(export_schema,'')=coalesce(oschema,'')
     and frec.filename=name||'_view.sql')
    loop
     insert into o2p_t_object(id,postgres_script,ostatus4o_code,
     postgres_schema,acsession4o_id,name,pgtype4o_code)
     values (nextval('o2p_q_object'),frec.filedata,'AUTO',oschema,
     p_acsession_id,porec.name,otrec.ot_code) returning id into pgoid;
     insert into o2p_t_object4projectobject
     (id,po4opo_id,o4opo_id) values
     (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
    end loop;
    --
   elsif otrec.ot_code='SYNONYM' then
    loop
     exit when coalesce(frec.filedata,'')='';
     pgtext := '';
     p := position(chr(10) in frec.filedata);
     if p=0 then l := frec.filedata; frec.filedata := '';
     else
      l := substring(frec.filedata,1,(p-1)::integer);
      frec.filedata := substring(frec.filedata,(p+1)::integer);
     end if;
     for porec in (select * from o2p_t_project_object
      where project4obj_code=prjcode and motype_code=otrec.ot_code
      and coalesce(export_schema,'')=coalesce(oschema,'')
      and l like lower('% '||name||' %'))
     loop
      pgtext := pgtext||l||chr(10);
      p := position(chr(10) in frec.filedata);
      l := substring(frec.filedata,1,(p-1)::integer);
      frec.filedata := substring(frec.filedata,(p+1)::integer);
      pgtext := pgtext||l||chr(10);
      p := position(chr(10) in frec.filedata);
      l := substring(frec.filedata,1,(p-1)::integer);
      frec.filedata := substring(frec.filedata,(p+1)::integer);
      pgtext := pgtext||l||chr(10);
      
      select id,attention_to into p,l from o2p_t_object_restriction
      where acsession4orestriction_id=p_acsession_id
      and po4orestriction_id=porec.id
      and rtype4orestriction_code='SOURCE_ISNOT_TABLE';
      
      if not found then
       insert into o2p_t_object(id,postgres_script,ostatus4o_code,
       postgres_schema,acsession4o_id,name,pgtype4o_code)
       values (nextval('o2p_q_object'),pgtext,'AUTO',oschema,
       p_acsession_id,porec.name,'VIEW') returning id into pgoid;
       insert into o2p_t_object4projectobject
      (id,po4opo_id,o4opo_id) values
      (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
      
      elsif l='PROCEDURE' then
       pgtext := 
'CREATE OR REPLACE FUNCTION '||porec.export_schema||'.'||porec.name||chr(10)||
'(param1 paramtype1,...) RETURNS void AS'||chr(10)||
'$body$'||chr(10)||
'begin'||chr(10)||
' perform '||substring(porec.comment,1,(position('(' in porec.comment)-1)::integer)||
'(param1,...);'||chr(10)||
'end;'||chr(10)||
'$body$'||chr(10)||
'LANGUAGE ''plpgsql'''||chr(10)||
'VOLATILE'||chr(10)||
'CALLED ON NULL INPUT'||chr(10)||
'SECURITY INVOKER'||chr(10)||
'PARALLEL UNSAFE'||chr(10)||
'COST 100;'||chr(10)||
'ALTER FUNCTION '||porec.export_schema||'.'||porec.name||
'(param1 paramtype1,...) RETURNS void'||
'OWNER TO '||porec.export_schema||chr(10)||
'GRANT ALL ON '||porec.export_schema||'.'||porec.name||
'(param1 paramtype1,...) RETURNS void TO '||porec.export_schema||';';
       insert into o2p_t_object(id,postgres_script,ostatus4o_code,
       postgres_schema,acsession4o_id,name,pgtype4o_code)
       values (nextval('o2p_q_object'),pgtext,'AUTO',oschema,
       p_acsession_id,porec.name,'FUNCTION') returning id into pgoid;
       insert into o2p_t_object4projectobject
      (id,po4opo_id,o4opo_id) values
      (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
      
      elsif l='FUNCTION' then
       pgtext := 
'CREATE OR REPLACE FUNCTION '||porec.export_schema||'.'||porec.name||chr(10)||
'(param1 paramtype1,...) RETURNS rettype AS'||chr(10)||
'$body$'||chr(10)||
'declare'||chr(10)||
' retval rettype'||chr(10)||
'begin'||chr(10)||
' select '||substring(porec.comment,1,(position('(' in porec.comment)-1)::integer)||
'(param1,...) into retval;'||chr(10)||
' return retval;'||chr(10)||
'end;'||chr(10)||
'$body$'||chr(10)||
'LANGUAGE ''plpgsql'''||chr(10)||
'VOLATILE'||chr(10)||
'CALLED ON NULL INPUT'||chr(10)||
'SECURITY INVOKER'||chr(10)||
'PARALLEL UNSAFE'||chr(10)||
'COST 100;'||chr(10)||
'ALTER FUNCTION '||porec.export_schema||'.'||porec.name||
'(param1 paramtype1,...) RETURNS rettype'||
'OWNER TO '||porec.export_schema||chr(10)||
'GRANT ALL ON '||porec.export_schema||'.'||porec.name||
'(param1 paramtype1,...) RETURNS rettype TO '||porec.export_schema||';';
       insert into o2p_t_object(id,postgres_script,ostatus4o_code,
       postgres_schema,acsession4o_id,name,pgtype4o_code)
       values (nextval('o2p_q_object'),pgtext,'AUTO',oschema,
       p_acsession_id,porec.name,'FUNCTION') returning id into pgoid;
       insert into o2p_t_object4projectobject
      (id,po4opo_id,o4opo_id) values
      (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
      
      elsif l='PACKAGE' then
       pgtext := 
'CREATE SCHEMA "'||porec.name||'" AUTHORIZATION '||porec.export_schema||';';
       insert into o2p_t_object(id,postgres_script,ostatus4o_code,
       postgres_schema,acsession4o_id,name,pgtype4o_code)
       values (nextval('o2p_q_object'),pgtext,'AUTO',porec.name,
       p_acsession_id,porec.name,'SCHEMA') returning id into pgoid;
       insert into o2p_t_object4projectobject
      (id,po4opo_id,o4opo_id) values
      (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
      pgtext :=
 'CREATE OR REPLACE FUNCTION '||porec.name||'.func1'||chr(10)||
'(param1 paramtype1,...) RETURNS rettype AS'||chr(10)||
'$body$'||chr(10)||
'declare'||chr(10)||
' retval rettype'||chr(10)||
'begin'||chr(10)||
' select '||substring(porec.comment,
(position('.' in porec.comment)+1)::integer,
(position('(' in porec.comment)-1-
position('.' in porec.comment))::integer)||'.func1'||
'(param1,...) into retval;'||chr(10)||
' return retval;'||chr(10)||
'end;'||chr(10)||
'$body$'||chr(10)||
'LANGUAGE ''plpgsql'''||chr(10)||
'VOLATILE'||chr(10)||
'CALLED ON NULL INPUT'||chr(10)||
'SECURITY INVOKER'||chr(10)||
'PARALLEL UNSAFE'||chr(10)||
'COST 100;'||chr(10)||
'ALTER FUNCTION '||porec.name||'.func1'||
'(param1 paramtype1,...) RETURNS rettype'||
'OWNER TO '||porec.name||';'||chr(10)||
'GRANT ALL ON '||porec.name||'.func1'||
'(param1 paramtype1,...) RETURNS rettype TO '||porec.name||';';
       insert into o2p_t_object(id,postgres_script,ostatus4o_code,
       postgres_schema,acsession4o_id,name,pgtype4o_code)
       values (nextval('o2p_q_object'),pgtext,'AUTO',porec.name,
       p_acsession_id,'FUNC1','FUNCTION') returning id into pgoid;
       insert into o2p_t_object4projectobject
      (id,po4opo_id,o4opo_id) values
      (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
      end if;
     end loop;
    end loop;
    --
   elsif otrec.ot_code='SEQUENCE' then
    loop
     exit when coalesce(frec.filedata,'')='';
     pgtext := '';
     p := position(chr(10) in frec.filedata);
     if p=0 then l := frec.filedata; frec.filedata := '';
     else
      l := substring(frec.filedata,1,(p-1)::integer);
      frec.filedata := substring(frec.filedata,(p+1)::integer);
     end if;
     for porec in (select * from o2p_t_project_object
      where project4obj_code=prjcode and motype_code=otrec.ot_code
      and coalesce(export_schema,'')=coalesce(oschema,'')
      and l like lower('% '||name||' %'))
     loop
      pgtext := pgtext||l||chr(10);
      insert into o2p_t_object(id,postgres_script,ostatus4o_code,
      postgres_schema,acsession4o_id,name,pgtype4o_code)
      values (nextval('o2p_q_object'),pgtext,'AUTO',oschema,
      p_acsession_id,porec.name,otrec.ot_code) returning id into pgoid;
      insert into o2p_t_object4projectobject
      (id,po4opo_id,o4opo_id) values
      (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
     end loop;
    end loop;
    --
   elsif otrec.ot_code='TYPE' then
    pgtext := ''; pgoid := null;
    for fline in (select * from o2p_f_l2t(frec.filedata,chr(10))) loop
     l := fline.value;
     --  
     continue when l like '-- Generated by%';
     continue when l like '-- Copyright%';
     continue when l like '-- DATASOURCE%';
     continue when l like 'SET client_encoding%';
     continue when l like '_set ON_ERROR_STOP%';
     if l like '%CREATE%' then
      if pgtext!='' and pgoid=0 then
       pgtext := trim(pgtext);
       --     
       select id into pgoid from o2p_t_object
       where acsession4o_id=p_acsession_id and
       postgres_schema=oschema and
       name=porec.name and
       pgtype4o_code=otrec.ot_code;
       if not found then
        insert into o2p_t_object(id,postgres_script,ostatus4o_code,
        postgres_schema,acsession4o_id,name,pgtype4o_code)
        values (nextval('o2p_q_object'),pgtext,'AUTO',oschema,
        p_acsession_id,porec.name,otrec.ot_code) returning id into pgoid;
       else
        update o2p_t_object set postgres_script=pgtext where id=pgoid;
       end if;
       insert into o2p_t_object4projectobject
       (id,po4opo_id,o4opo_id) values
       (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
      end if;
      --      
      pgtext := l||chr(10);
      --   ,   
      select * into porec from o2p_t_project_object
      where project4obj_code=prjcode and motype_code=otrec.ot_code
      and coalesce(export_schema,'')=coalesce(oschema,'')
      and l like lower('% '||name||' %');
      if not found then
       pgoid := -1;
      else
       pgoid := 0;
      end if;
     elsif lower(l) like '%unsupported%' then null; 
     else
      --     
      pgtext := pgtext||l||chr(10);
     end if;
    end loop;
    if pgtext!='' and pgoid=0 then
     pgtext := trim(pgtext);
     --     
     select id into pgoid from o2p_t_object
     where acsession4o_id=p_acsession_id and
      postgres_schema=oschema and
      name=porec.name and
      pgtype4o_code=otrec.ot_code;
     if not found then
      insert into o2p_t_object(id,postgres_script,ostatus4o_code,
      postgres_schema,acsession4o_id,name,pgtype4o_code)
      values (nextval('o2p_q_object'),pgtext,'AUTO',oschema,
      p_acsession_id,porec.name,otrec.ot_code) returning id into pgoid;
     else
      update o2p_t_object set postgres_script=pgtext where id=pgoid;
     end if;
     insert into o2p_t_object4projectobject
     (id,po4opo_id,o4opo_id) values
     (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
    end if;
   --
   elsif otrec.ot_code='DIRECTORY' then
    pgtext := ''; pgoid := null;
    loop
     exit when coalesce(frec.filedata,'')='';
     p := position(chr(10) in frec.filedata);
     if p=0 then l := frec.filedata; frec.filedata := '';
     else
      l := substring(frec.filedata,1,(p-1)::integer);
      frec.filedata := substring(frec.filedata,(p+1)::integer);
     end if;
     if pgoid is null then
      select * into porec from o2p_t_project_object
      where project4obj_code=prjcode and motype_code=otrec.ot_code
      and l like '%'''||name||'''%';
      if not found then pgoid := null;
      else
       pgoid := 0;
       pgtext := pgtext||l;
      end if;
      continue;
     else
      pgtext := pgtext||chr(10)||l;
      --     
      insert into o2p_t_object(id,postgres_script,ostatus4o_code,
      postgres_schema,acsession4o_id,name,pgtype4o_code)
      values (nextval('o2p_q_object'),pgtext,'AUTO',oschema,
      p_acsession_id,porec.name,'DML') returning id into pgoid;
      insert into o2p_t_object4projectobject
      (id,po4opo_id,o4opo_id) values
      (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
      pgtext := ''; pgoid := null;
     end if;
    end loop;
   --
   elsif otrec.ot_code='DBLINK' then
    pgtext := ''; pgoid := null;
    loop
     exit when coalesce(frec.filedata,'')='';
     p := position(chr(10) in frec.filedata);
     if p=0 then l := frec.filedata; frec.filedata := '';
     else
      l := substring(frec.filedata,1,(p-1)::integer);
      frec.filedata := substring(frec.filedata,(p+1)::integer);
     end if;
     select * into porec from o2p_t_project_object
     where project4obj_code=prjcode and motype_code=otrec.ot_code
     and l like lower('% '||name|| '%');
     if not found then continue;
     else
      pgtext := l;
      if l like '%CREATE SERVER%' then
       insert into o2p_t_object(id,postgres_script,ostatus4o_code,
       postgres_schema,acsession4o_id,name,pgtype4o_code)
       values (nextval('o2p_q_object'),pgtext,'AUTO',null,
       p_acsession_id,porec.name,'SERVER') returning id into pgoid;
      elsif l like '%CREATE USER%' then
       insert into o2p_t_object(id,postgres_script,ostatus4o_code,
       postgres_schema,acsession4o_id,name,pgtype4o_code)
       values (nextval('o2p_q_object'),pgtext,'AUTO',null,
       p_acsession_id,porec.name,'USER') returning id into pgoid;
      end if;
      insert into o2p_t_object4projectobject
      (id,po4opo_id,o4opo_id) values
      (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
     end if;
    end loop;
   --
   elsif otrec.ot_code='TABLESPACE' then
    continue when frec.filename='TBSP_INDEXES_tablespace.sql';
    pgtext := ''; pgoid := null;
    loop
     exit when coalesce(frec.filedata,'')='';
     p := position(chr(10) in frec.filedata);
     if p=0 then l := frec.filedata; frec.filedata := '';
     else
      l := substring(frec.filedata,1,(p-1)::integer);
      frec.filedata := substring(frec.filedata,(p+1)::integer);
     end if;
     continue when l not like '%CREATE TABLESPACE%';
     --
     select * into porec from o2p_t_project_object
     where project4obj_code=prjcode and motype_code=otrec.ot_code
     and l like lower('% '||name|| '%');
     continue when not found;
     --
     pgtext := l;
     insert into o2p_t_object(id,postgres_script,ostatus4o_code,
     postgres_schema,acsession4o_id,name,pgtype4o_code)
     values (nextval('o2p_q_object'),pgtext,'AUTO',null,
     p_acsession_id,porec.name,otrec.ot_code) returning id into pgoid;
     insert into o2p_t_object4projectobject
     (id,po4opo_id,o4opo_id) values
     (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
    end loop;
   --
   elsif otrec.ot_code='USER' then
    pgoid := null;
    select array_agg(o2p_t_project_object) into polist
    from o2p_t_project_object
    where project4obj_code=prjcode and motype_code=otrec.ot_code;
    --
    select array_agg(o2p_t_project_object) into po4grantlist
    from o2p_t_project_object
    where project4obj_code=prjcode;
    --
    linenumber := 0;
    loop
     exit when coalesce(frec.filedata,'')='';
     p := position(chr(10) in frec.filedata);
     if p=0 then l := frec.filedata; frec.filedata := '';
     else
      l := substring(frec.filedata,1,(p-1)::integer);
      frec.filedata := substring(frec.filedata,(p+1)::integer);
     end if;
     --
     linenumber := linenumber+1;
     if l like '%CREATE USER%' then
      i := 0;  pgtext := l;
      for j in 1..coalesce(cardinality(polist),0) loop
       if l like '% '||polist[j].name||' %' then
        i := j; exit;        
       end if;
      end loop;
      continue when i=0;
      --
      insert into o2p_t_object(id,postgres_script,ostatus4o_code,
      postgres_schema,acsession4o_id,name,pgtype4o_code)
      values (nextval('o2p_q_object'),l,'AUTO',null,
      p_acsession_id,polist[i].name,otrec.ot_code)
      returning * into o;
      --
      olist[coalesce(cardinality(olist),0)+1] := o;
      --
      insert into o2p_t_object4projectobject
      (id,po4opo_id,o4opo_id) values
      (nextval('o2p_q_object4projectobject'),polist[i].id,o.id);
     --
     elsif l like '% OWNER TO %' then
      i := 0;  pgtext := l;
      for j in 1..coalesce(cardinality(olist),0) loop
       if l like '% OWNER TO '||lower(olist[j].name)||';%' then
        i := j; exit;
       end if;       
      end loop;
      continue when i=0;
      --
      k := 0;
      for j in 1..coalesce(cardinality(po4grantlist),0) loop
       if l like '% '||lower(po4grantlist[j].name)||' OWNER TO %' then
        k := j; exit;        
       end if;
      end loop;
      continue when k=0;
      --
      o := olist[i]; o.postgres_script := o.postgres_script||chr(10)||l; olist[i] := o;
     --
     elsif l like '%GRANT % TO %' then
      i := 0;  pgtext := l;
      for j in 1..coalesce(cardinality(olist),0) loop
       if l like '% TO '||lower(olist[j].name)||';%' then
        i := j; exit;
       end if;       
      end loop;
      continue when i=0;
      --
      k := 0;
      for j in 1..coalesce(cardinality(po4grantlist),0) loop
       if l like '% '||lower(po4grantlist[j].name)||' TO %' then
        k := j; exit;        
       end if;
      end loop;
      continue when k=0;
      --
      o := olist[i]; o.postgres_script := o.postgres_script||chr(10)||l; olist[i] := o;
     --
     elsif l like '%REVOKE%' then      
      i := 0;
      for j in 1..coalesce(cardinality(olist),0) loop
       if pgtext like '% TO '||lower(olist[j].name)||';' then
        i := j; exit;
       end if;       
      end loop;
      continue when i=0;
      --
      k := 0;
      for j in 1..coalesce(cardinality(po4grantlist),0) loop
       if l like '% ON% '||lower(po4grantlist[j].name)||' FROM%' then
        k := j; exit;        
       end if;
      end loop;
      continue when k=0;
      --     
      o := olist[i]; o.postgres_script := o.postgres_script||chr(10)||l; olist[i] := o;
     --
     else
      continue;
     end if;
    end loop; --    
    --
    for j in 1..coalesce(cardinality(olist),0) loop
     update o2p_t_object set postgres_script=olist[j].postgres_script
     where id=olist[j].id;
    end loop;
   --
   elsif otrec.ot_code='ROLE' then
    select array_agg(o2p_t_project_object) into polist
    from o2p_t_project_object
    where project4obj_code=prjcode and motype_code=otrec.ot_code;
    --
    select array_agg(o2p_t_project_object) into po4grantlist
    from o2p_t_project_object
    where project4obj_code=prjcode and motype_code in
    ('TABLE','VIEW','MVIEW',
    'PROCEDURE','FUNCTION','PACKAGE',
    'DIRECTORY','ROLE');
    --
    linenumber := 0;
    loop
     exit when coalesce(frec.filedata,'')='';
     p := position(chr(10) in frec.filedata);
     if p=0 then l := frec.filedata; frec.filedata := '';
     else
      l := substring(frec.filedata,1,(p-1)::integer);
      frec.filedata := substring(frec.filedata,(p+1)::integer);
     end if;
     --
     linenumber := linenumber+1;
     --
     if l like '%CREATE ROLE%' then
      i := 0;
      for j in 1..coalesce(cardinality(polist),0) loop
       if l like '% '||polist[j].name||';' or l like '% '||polist[j].name||' %' then
        i := j; exit;        
       end if;
      end loop;
      continue when i=0;
      --
      insert into o2p_t_object(id,postgres_script,ostatus4o_code,
      postgres_schema,acsession4o_id,name,pgtype4o_code)
      values (nextval('o2p_q_object'),l,'AUTO',null,
      p_acsession_id,polist[i].name,otrec.ot_code) returning * into o;
      --
      olist[coalesce(cardinality(olist),0)+1] := o;
      --
      insert into o2p_t_object4projectobject
      (id,po4opo_id,o4opo_id) values
      (nextval('o2p_q_object4projectobject'),polist[i].id,o.id);
      --
      continue;
     -- 
     elsif l like '%GRANT% TO %' then
      i := 0;
      for j in 1..coalesce(cardinality(olist),0) loop
       if l like '% TO '||lower(olist[j].name)||';%' then
        i := j; exit;
       end if;       
      end loop;
      continue when i=0;
      --
      k := 0;
      for j in 1..coalesce(cardinality(po4grantlist),0) loop
       if l like '% ON% '||lower(po4grantlist[j].name)||' TO%' then
        k := j; exit;        
       end if;
      end loop;
      continue when k=0;
      --
      o := olist[i]; o.postgres_script := o.postgres_script||chr(10)||l; olist[i] := o;
     else
      continue;
     end if;
    end loop; --    
    --
    for j in 1..coalesce(cardinality(olist),0) loop
     update o2p_t_object set postgres_script=olist[j].postgres_script
     where id=olist[j].id;
    end loop;
   --
   elsif otrec.ot_code='TABLE' then
    if frec.filename='table.sql' then
     pgtext := ''; pgoid := null;
     loop
      exit when coalesce(frec.filedata,'')='';
      p := position(chr(10) in frec.filedata);
      if p=0 then l := frec.filedata; frec.filedata := '';
      else
       l := substring(frec.filedata,1,(p-1)::integer);
       frec.filedata := substring(frec.filedata,(p+1)::integer);
      end if;
      if l like '%CREATE TABLE%' then
       if pgoid>0 then
        --    
        insert into o2p_t_object(id,postgres_script,ostatus4o_code,
        postgres_schema,acsession4o_id,name,pgtype4o_code)
        values (nextval('o2p_q_object'),pgtext,'AUTO',porec.export_schema,
        p_acsession_id,coalesce(porec.dst_tab_name,porec.name),otrec.ot_code) returning id into pgoid;
        insert into o2p_t_object4projectobject
        (id,po4opo_id,o4opo_id) values
        (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
        pgoid := null;
       end if;
       select * into porec from o2p_t_project_object
       where project4obj_code=prjcode and motype_code=otrec.ot_code
       and l like lower('% '||coalesce(dst_tab_name,name)||' %');
       if found then
        --     
        pgoid := 1;
        pgtext := l;
       else
        select * into porec from o2p_t_project_object
        where project4obj_code=prjcode and motype_code=otrec.ot_code
        and l like lower('% "'||coalesce(dst_tab_name,name)||'" %');
        if found then
         --     
         pgoid := 1;
         pgtext := l;
        else
         continue; --      
        end if;
       end if;
      elsif pgoid>0 then
       --     
       pgtext := pgtext||chr(10)||l;
      else
       continue; --       
      end if;  
     end loop;
     if pgoid>0 then
       --     
       insert into o2p_t_object(id,postgres_script,ostatus4o_code,
       postgres_schema,acsession4o_id,name,pgtype4o_code)
       values (nextval('o2p_q_object'),pgtext,'AUTO',porec.export_schema,
       p_acsession_id,coalesce(porec.dst_tab_name,porec.name),otrec.ot_code) returning id into pgoid;
       insert into o2p_t_object4projectobject
       (id,po4opo_id,o4opo_id) values
       (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
       pgoid := null;
     end if;   
    elsif frec.filename='INDEXES_table.sql' then
     pgtext := ''; pgoid := null;
     loop
      exit when coalesce(frec.filedata,'')='';
      p := position(chr(10) in frec.filedata);
      if p=0 then l := frec.filedata; frec.filedata := '';
      else
       l := substring(frec.filedata,1,(p-1)::integer);
       frec.filedata := substring(frec.filedata,(p+1)::integer);
      end if;
      continue when l not like '%CREATE INDEX%';
      select * into porec from o2p_t_project_object
      where project4obj_code=prjcode and motype_code='INDEX'
      and l like lower('% '||name||' %');
      if found then
       pgtext := l;
       insert into o2p_t_object(id,postgres_script,ostatus4o_code,
       postgres_schema,acsession4o_id,name,pgtype4o_code)
       values (nextval('o2p_q_object'),pgtext,'AUTO',porec.export_schema,
       p_acsession_id,porec.name,'INDEX') returning id into pgoid;
       insert into o2p_t_object4projectobject
       (id,po4opo_id,o4opo_id) values
       (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
      else
       continue; --      
      end if; 
     end loop;
    -- 
    elsif frec.filename='CONSTRAINTS_table.sql' then
     --    !
     pgtext := ''; pgoid := null;
     loop
      exit when coalesce(frec.filedata,'')='';
      p := position(chr(10) in frec.filedata);
      if p=0 then l := frec.filedata; frec.filedata := '';
      else
       l := substring(frec.filedata,1,(p-1)::integer);
       frec.filedata := substring(frec.filedata,(p+1)::integer);
      end if;
      continue when l not like '%ADD CONSTRAINT%' and l not like '%ADD UNIQUE%';
      if l like '%ADD CONSTRAINT%' then
       select * into porec from o2p_t_project_object
       where project4obj_code=prjcode and motype_code='CONSTRAINT'
       and l like lower('% '||name||' %');
       if not found then
        select * into porec from o2p_t_project_object
        where project4obj_code=prjcode and motype_code='CONSTRAINT'
        and l like lower('% "'||name||'" %');
        if not found then
         continue;
        end if;
       end if;
       pgtext := l;
       insert into o2p_t_object(id,postgres_script,ostatus4o_code,
       postgres_schema,acsession4o_id,name,pgtype4o_code)
       values (nextval('o2p_q_object'),pgtext,'AUTO',porec.export_schema,
       p_acsession_id,porec.name,'CONSTRAINT') returning id into pgoid;
       insert into o2p_t_object4projectobject
       (id,po4opo_id,o4opo_id) values
       (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
      --
      elsif l like '%ADD UNIQUE%' then
       raise notice 'l=%',l;
       --   
       select * into porec from o2p_t_project_object
       where project4obj_code=prjcode and motype_code='TABLE'
       and l like lower('% '||name||' %');
       if not found then
        select * into porec from o2p_t_project_object
        where project4obj_code=prjcode and motype_code='TABLE'
        and l like lower('% "'||name||'" %');
        if not found then
         -- ,    ,    
         continue;
        end if;
       end if;
       raise notice 'porec.id=%',porec.id;
       p1 := position('(' in l);
       p2 := position(')' in l);
       str := substring(l from p1 for p2-p1+1);
       raise notice 'str=%',str;
       p1 := porec.id;
       select * into porec from o2p_t_project_object t
       where t.project4obj_code=prjcode
       and t.motype_code='CONSTRAINT'
       and t.po4po_id=p1
       and lower(t.name) like 'sys%'
       and lower(t.oracle_script) like '% unique %'
       and lower(replace(replace(t.oracle_script,'"',''),chr(10),' ')) like '% '||str||' %';
       if not found then --   -  !!!
        select * into porec from o2p_t_project_object t
        where t.project4obj_code=prjcode
        and t.motype_code='INDEX'
        and t.po4po_id=p1
        and lower(t.name) like 'sys%'
        and lower(t.oracle_script) like '% unique %'
        and lower(replace(replace(t.oracle_script,'"',''),chr(10),' ')) like '% '||str||' %';
        if not found then
         --   ,        
         continue;
        end if;
       end if;
       raise notice 'porec.id=%',porec.id;
       pgtext := l;
       insert into o2p_t_object(id,postgres_script,ostatus4o_code,
       postgres_schema,acsession4o_id,name,pgtype4o_code)
       values (nextval('o2p_q_object'),pgtext,'AUTO',porec.export_schema,
       p_acsession_id,porec.name,'CONSTRAINT') returning id into pgoid;
       insert into o2p_t_object4projectobject
       (id,po4opo_id,o4opo_id) values
       (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
      end if;
     end loop;
    -- 
    elsif frec.filename='FKEYS_table.sql' then
     pgtext := ''; pgoid := null;
     loop
      exit when coalesce(frec.filedata,'')='';
      p := position(chr(10) in frec.filedata);
      if p=0 then l := frec.filedata; frec.filedata := '';
      else
       l := substring(frec.filedata,1,(p-1)::integer);
       frec.filedata := substring(frec.filedata,(p+1)::integer);
      end if;
      continue when l not like '%ADD CONSTRAINT%';
      select * into porec from o2p_t_project_object
      where project4obj_code=prjcode and motype_code='FKEY'
      and l like lower('% '||name||' %');
      if found then
       pgtext := l;
       insert into o2p_t_object(id,postgres_script,ostatus4o_code,
       postgres_schema,acsession4o_id,name,pgtype4o_code)
       values (nextval('o2p_q_object'),pgtext,'AUTO',porec.export_schema,
       p_acsession_id,porec.name,'FKEY') returning id into pgoid;
       insert into o2p_t_object4projectobject
       (id,po4opo_id,o4opo_id) values
       (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
      else
       continue; --       
      end if; 
     end loop; 
    end if;
   --
   elsif otrec.ot_code = 'PACKAGE' then
     if frec.filename = 'package.sql' then
       pgtext := ''; pgoid := null;
       loop
        exit when coalesce(frec.filedata,'')='';
        p := position(chr(10) in frec.filedata);
        if p=0 then l := frec.filedata; frec.filedata := '';
        else
         l := substring(frec.filedata,1,(p-1)::integer);
         frec.filedata := substring(frec.filedata,(p+1)::integer);
        end if;
        if l like '%CREATE TYPE%' then
        raise notice 'OK';
	      --      
  		  pgoid := 1;
          pgtext := l;
		  o.name := substr(l, strpos(l,'CREATE TYPE')+12);
		  o.name := substr(o.name, 1, strpos(o.name,' ')-1);
		  o.postgres_schema := upper(substr(o.name, 1, strpos(o.name,'.')-1));
          o.name := upper(substr(o.name, strpos(o.name,'.')+1));
	    elsif pgoid>0 then
	      --      
		  pgtext:=pgtext||chr(10)||l;
        else
         continue; --       
	    end if;
        if l like '%;%' then
	      if pgoid>0 then
            --   ,    postgres-
            select * into porec from o2p_t_project_object
             where project4obj_code=prjcode and motype_code=otrec.ot_code
               and coalesce(export_schema,'')=coalesce(oschema,'')
               and upper(name) = o.postgres_schema;
            -- ,         ,
            --      
            select id into pgoid from o2p_t_object t1
            where acsession4o_id=p_acsession_id
            and pgtype4o_code='TYPE'
            and postgres_schema=o.postgres_schema
            and name=o.name
            and exists (select 1 from o2p_t_object4projectobject t2
            where t2.po4opo_id=porec.id and t2.o4opo_id=t1.id);
	        --     
            if found THEN
              update o2p_t_object set postgres_script=pgtext where id=pgoid;
            else
              insert into o2p_t_object(id,postgres_script,ostatus4o_code,
                postgres_schema,acsession4o_id,name,pgtype4o_code)
              values (nextval('o2p_q_object'),pgtext,'AUTO',o.postgres_schema,
                p_acsession_id,o.name,'TYPE') returning id into pgoid;
              insert into o2p_t_object4projectobject (id,po4opo_id,o4opo_id) 
 		      values (nextval('o2p_q_object4projectobject'),porec.id,pgoid);
            end if;
            pgoid := null;
		  end if;  
	    end if;
       end loop;
	 end if;
   end if; --    
  end loop; --   
 end loop; --    
END;
$body1$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_r_create_pgobjects (p_acsession_id numeric)
  OWNER TO ora2pg_project;