CREATE OR REPLACE FUNCTION ora2pg_project.o2p_r_duplicate_project (
  p_project_code text,
  p_new_project_code text
)
RETURNS void AS
$body$
declare
 projectrec o2p_t_project;
 memrec o2p_t_user_in_project;
BEGIN
 select * into projectrec from o2p_t_project where code=p_project_code;
 projectrec.code := p_new_project_code;
 projectrec.finish_fact_date := null;
 projectrec.start_date := null;
 projectrec.status4project_code := 'NEW';
 insert into o2p_t_project values (projectrec.*);
 for memrec in (select * from o2p_t_user_in_project t
  where t.project4usr_code=p_project_code and t.is_leader='Y' order by id desc)
 loop
  memrec.project4usr_code := p_new_project_code;
  memrec.id := nextval('o2p_q_user_in_project');
  memrec.date_from := current_date;
  memrec.date_to := o2p_f_get_defhist_to();
  insert into o2p_t_user_in_project values (memrec.*);
 end loop; 
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_r_duplicate_project (p_project_code text, p_new_project_code text)
  OWNER TO ora2pg_project;