CREATE OR REPLACE FUNCTION ora2pg_project.o2p_r_make_objlist_4_acsession (
  p_acsession_id numeric
)
RETURNS void AS
$body$
DECLARE
  v_project_code text;
  v_export_schema text;
  v_objects4run text;
  obj record;
BEGIN
  select project4acsession_code, oschema4acsession_name, objects4run_code
  into v_project_code,v_export_schema, v_objects4run from o2p_t_acsession where id = p_acsession_id;

  for obj in (select t1.id,t1.name from o2p_t_project_object t1
               where project4obj_code = v_project_code
               and coalesce(export_schema,v_export_schema) = v_export_schema
			   and ((coalesce(postatus4po_code,'NEW') in ('NEW','WORK') and v_objects4run = 'ALL') or o2p_f_is_conversion_required(t1.id) = 'Y')
               and exists (select 1 from o2p_t_acsession_ot t2 where t2.acsession4acot_id = p_acsession_id and t2.ot_code = t1.motype_code)
	          order by t1.name)
  loop
    insert into o2p_t_po2acsession (acsession4po_id, po4acsession_id) values (p_acsession_id, obj.id);
  end loop;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_r_make_objlist_4_acsession (p_acsession_id numeric)
  OWNER TO ora2pg_project;