CREATE OR REPLACE FUNCTION ora2pg_project.o2p_r_set_convert_status (
  p_acsession_id ora2pg_project.o2p_d_id,
  p_ot_code ora2pg_project.o2p_d_code32 = NULL::integer
)
RETURNS void AS
$body$
DECLARE
  r record;
  res o2p_d_code32 := 'OK';
BEGIN
  if p_ot_code is not null then
    for r in (
      select coalesce(min(case when t1.rescode4po_code='OK' then 'Y' else null end),'')||
             coalesce(min(case when t1.rescode4po_code='ERROR' then 'E' else null end),'')||
             coalesce(min(case when t1.rescode4po_code='WARNING' then 'W' else null end),'')
             sign
      from o2p_t_po2acsession t1
      join o2p_t_project_object t2 on t2.id=t1.po4acsession_id
      where acsession4po_id=p_acsession_id and t2.motype_code=p_ot_code)
    loop
      if r.sign like '%E%' and r.sign not like '%Y%' and r.sign not like '%W%' then
        update o2p_t_acsession_ot set rescode4acot_code='ERROR'
        where acsession4acot_id=p_acsession_id and ot_code=p_ot_code;
      elsif r.sign not like '%E%' and r.sign like '%Y%' and r.sign not like '%W%' then
        update o2p_t_acsession_ot set rescode4acot_code='OK'
        where acsession4acot_id=p_acsession_id and ot_code=p_ot_code;
      else
        update o2p_t_acsession_ot set rescode4acot_code='WARNING'
        where acsession4acot_id=p_acsession_id and ot_code=p_ot_code;
      end if;
    end loop;
  else
    for r in (
      select coalesce(min(case when rescode4acot_code='OK' then 'Y' else null end),'')||
             coalesce(min(case when rescode4acot_code='ERROR' then 'E' else null end),'')||
             coalesce(min(case when rescode4acot_code='WARNING' then 'W' else null end),'')
             sign
      from o2p_t_acsession_ot where acsession4acot_id=p_acsession_id)
    loop
      if r.sign like '%E%' and r.sign not like '%Y%' and r.sign not like '%W%' then
        update o2p_t_acsession set rescode4acsession_code='ERROR' where id=p_acsession_id;
      elsif r.sign not like '%E%' and r.sign like '%Y%' and r.sign not like '%W%' then
        update o2p_t_acsession set rescode4acsession_code='OK' where id=p_acsession_id;
      else
        update o2p_t_acsession set rescode4acsession_code='WARNING' where id=p_acsession_id;
      end if;
    end loop;
  end if;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_r_set_convert_status (p_acsession_id ora2pg_project.o2p_d_id, p_ot_code ora2pg_project.o2p_d_code32)
  OWNER TO ora2pg_project;