CREATE OR REPLACE FUNCTION ora2pg_project.o2p_r_task_status (
  p_acsession_id numeric,
  p_task_code ora2pg_project.o2p_d_code32,
  p_res_code ora2pg_project.o2p_d_code32,
  p_error_text ora2pg_project.o2p_d_text = NULL::text
)
RETURNS void AS
$body$
declare
 cnt numeric;
 cnt_ready numeric;
 cnt_error numeric;
 r record;
BEGIN
  select id into cnt from o2p_t_acsession where id=p_acsession_id for no key update;
  update o2p_t_acsession_task set rescode4task_code=p_res_code, error_text = p_error_text
  where acsession4task_id=p_acsession_id and code=p_task_code;
  
  if p_task_code='O2P_T_AUTO_CONVERT' then
    execute o2p_r_convertlog(p_acsession_id::o2p_d_id);
    for r in (select ot_code from o2p_t_acsession_ot where acsession4acot_id=p_acsession_id) loop
      execute o2p_r_set_convert_status(p_acsession_id::o2p_d_id,r.ot_code);
    end loop;
  end if;
  
  select count(*),
  count(rescode4task_code),
  count(case when rescode4task_code='TASKERROR' then rescode4task_code else null end)
  into cnt,cnt_ready,cnt_error
  from o2p_t_acsession_task where acsession4task_id=p_acsession_id;
  
  if cnt_error>0 then
   update o2p_t_acsession set rescode4acsession_code='TASKERROR' where id=p_acsession_id;
  elsif cnt=cnt_ready then
   execute o2p_r_set_convert_status(p_acsession_id::o2p_d_id);
  end if;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_project.o2p_r_task_status (p_acsession_id numeric, p_task_code ora2pg_project.o2p_d_code32, p_res_code ora2pg_project.o2p_d_code32, p_error_text ora2pg_project.o2p_d_text)
  OWNER TO ora2pg_project;