CREATE VIEW ora2pg_project.o2p_v_autoobject (
    motype_code,
    project_code,
    po_id,
    id,
    postgres_script,
    description,
    postgres_schema,
    acsession4o_id,
    name,
    pgtype4o_code,
    pgscript_id)
AS
SELECT t4.ot_code AS motype_code,
    t4.project_code,
    t5.po4opo_id AS po_id,
    t3.id,
    t3.postgres_script,
    t3.description,
    t3.postgres_schema,
    t3.acsession4o_id,
    t3.name,
    t3.pgtype4o_code,
    t3.pgscript_id
FROM o2p_t_object t3
     JOIN (
    SELECT DISTINCT t2.ot_code,
            first_value(t1.project4acsession_code) OVER (PARTITION BY
                t1.project4acsession_code, t2.ot_code
    ORDER BY t2.acsession4acot_id DESC) AS project_code,
            first_value(t2.acsession4acot_id) OVER (PARTITION BY
                t1.project4acsession_code, t2.ot_code
    ORDER BY t2.acsession4acot_id DESC) AS id
    FROM o2p_t_acsession_ot t2
             JOIN o2p_t_acsession t1 ON t1.id::integer = t2.acsession4acot_id::integer
    WHERE t1.rescode4acsession_code::text = 'OK'::text
    ) t4 ON t3.acsession4o_id::integer = t4.id::integer
     JOIN o2p_t_object4projectobject t5 ON t5.o4opo_id::integer = t3.id::integer
     JOIN o2p_t_project_object t6 ON t6.id::integer = t5.po4opo_id::integer AND
         t6.motype_code::text = t4.ot_code::text;

ALTER VIEW ora2pg_project.o2p_v_autoobject
  OWNER TO ora2pg_project;