﻿CREATE OR REPLACE FUNCTION ora2pg_projexp.o2p_f_export_project_user (
  p_user_in_project_id ora2pg_project.o2p_d_id
)
RETURNS text AS
$body$
DECLARE
  u record;
  c record;
  g record;
  vRes text := '';
  vResult text := '';
BEGIN
  -- Данные об участнике проекта.
  for u in (select uip.*, usr.name user_name, usr.notes user_notes
              from ora2pg_project.o2p_t_user_in_project uip
              join ora2pg_project.o2p_t_user usr on usr.username = uip.user_username
             where uip.id = p_user_in_project_id)
  loop
    if u.user_username is null then continue; end if;
	vRes := vRes||'  select count(*) into cnt from o2p_t_user where username = '''||u.user_username||''';'||chr(10);
	vRes := vRes||'  if cnt = 0 then'||chr(10);
	vRes := vRes||'    insert into o2p_t_user (username, name, notes)'||chr(10)||'    values (';
	vRes := vRes||ora2pg_projexp.o2p_f_make_tabcol_value('o2p_t_user','username',u.user_username,'C')||', ';
	vRes := vRes||ora2pg_projexp.o2p_f_make_tabcol_value('o2p_t_user','name',u.user_name,'T')||', ';
	vRes := vRes||ora2pg_projexp.o2p_f_make_tabcol_value('o2p_t_user','notes',u.user_notes,'T')||');'||chr(10);
	vRes := vRes||'  end if;'||chr(10);
    vRes := vRes||'  insert into o2p_t_user_in_project (id, user_username, project4usr_code, date_from, date_to, is_leader) '||chr(10)||'  values (';
	vRes := vRes||'nextval(''o2p_q_user_in_project''), ';
	vRes := vRes||ora2pg_projexp.o2p_f_make_tabcol_value('o2p_t_user_in_project','username',u.user_username,'C')||', ';
	vRes := vRes||'GV_PROJECT_CODE, ';
	vRes := vRes||ora2pg_projexp.o2p_f_make_tabcol_value('o2p_t_user_in_project','date_from',to_char(u.date_from,'dd.mm.yyyy'),'D')||', ';
	vRes := vRes||ora2pg_projexp.o2p_f_make_tabcol_value('o2p_t_user_in_project','date_to',to_char(u.date_to,'dd.mm.yyyy'),'D')||', ';
	vRes := vRes||ora2pg_projexp.o2p_f_make_tabcol_value('o2p_t_user_in_project','is_leader',u.is_leader,'C')||')'||chr(10);
	vRes := vRes||'  returning id into nID;'||chr(10);
	vRes := vRes||'  perform ora2pg_projexp.o2p_r_set_id(''o2p_t_user_in_project'', '||u.id||', nID);'||chr(10);
	for c in (select * from lui_t_user where user_name = u.user_username and app_code = 'LUI4ORA2PG')
	loop
	  vRes := vRes||'  select count(*) into cnt from lui_t_user where user_name = '''||u.user_username||''' and app_code = ''LUI4ORA2PG'';'||chr(10);
	  vRes := vRes||'  if cnt = 0 then'||chr(10);
	  vRes := vRes||'    insert into lui_t_user (user_name, app_code, creation_datetime, created_by, notes)'||chr(10)||'    values (';
  	  vRes := vRes||ora2pg_projexp.o2p_f_make_tabcol_value('lui_t_user','user_name',c.user_name,'C')||', ';
	  vRes := vRes||ora2pg_projexp.o2p_f_make_tabcol_value('lui_t_user','app_code',c.app_code,'C')||', ';
	  vRes := vRes||ora2pg_projexp.o2p_f_make_tabcol_value('lui_t_user','creation_datetime',to_char(c.creation_datetime,'dd.mm.yyyy hh24:mi:ss'),'DT')||', '||chr(10);
	  vRes := vRes||ora2pg_projexp.o2p_f_make_tabcol_value('lui_t_user','created_by',c.created_by,'C')||', ';
	  vRes := vRes||ora2pg_projexp.o2p_f_make_tabcol_value('lui_t_user','notes',c.notes,'T')||');'||chr(10);
	  for g in (select * from lui_t_user_in_group where user_name = c.user_name and app_code = c.app_code)
	  loop
	    vRes := vRes||'    insert into lui_t_user_in_group (user_name, app_code, usersgroup_code)'||chr(10)||'    values (';
  	    vRes := vRes||ora2pg_projexp.o2p_f_make_tabcol_value('lui_t_user_in_group','user_name',g.user_name,'C')||', ';
	    vRes := vRes||ora2pg_projexp.o2p_f_make_tabcol_value('lui_t_user_in_group','app_code',g.app_code,'C')||', ';
	    vRes := vRes||ora2pg_projexp.o2p_f_make_tabcol_value('lui_t_user_in_group','usersgroup_code',g.usersgroup_code,'C')||');'||chr(10);
	  end loop;
	  vRes := vRes||'  end if;'||chr(10);
	end loop;
  end loop;
  return vRes;
END;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER
PARALLEL UNSAFE
COST 100;

ALTER FUNCTION ora2pg_projexp.o2p_f_export_project_user (p_user_in_project_id ora2pg_project.o2p_d_id)
  OWNER TO ora2pg_project;