﻿set search_path=ora2pg_projexp,ora2pg_project,lui;

begin;

do $remove_lui4ora2pg$
declare
  o record;
begin
  --------------------------------------------
  -- 1. СХЕМА ora2pg_projexp
  -- 1.1. Удаление функций
  for o in (select n.nspname, p.proname,
                   pg_catalog.array_to_string(array(select pg_catalog.format_type(p.proargtypes[s.i], null)
				                                      from pg_catalog.generate_series(0, pg_catalog.array_upper(p.proargtypes, 1)) AS s(i)), ', ') arg_types
              from pg_catalog.pg_proc p left join pg_catalog.pg_namespace n on n.oid = p.pronamespace where n.nspname = 'ora2pg_projexp')
  loop
    execute 'drop function if exists '||o.nspname||'.'||o.proname||'('||o.arg_types||') cascade';
  end loop;
  -- 1.2. Удаление таблиц
  for o in (select table_schema, table_name from information_schema.tables where table_schema = 'ora2pg_projexp')
  loop
    execute 'drop table if exists '||o.table_schema||'.'||o.table_name||' cascade';
  end loop;
  -- 1.3. Удаление схемы ora2pg_projexp
  execute 'drop schema if exists ora2pg_projexp';
  --------------------------------------------
  -- 2. СХЕМА ora2pg_project
  -- 2.1. Удаление функций
  for o in (select n.nspname, p.proname,
                   pg_catalog.array_to_string(array(select pg_catalog.format_type(p.proargtypes[s.i], null)
				                                      from pg_catalog.generate_series(0, pg_catalog.array_upper(p.proargtypes, 1)) AS s(i)), ', ') arg_types
              from pg_catalog.pg_proc p left join pg_catalog.pg_namespace n on n.oid = p.pronamespace where n.nspname = 'ora2pg_project')
  loop
    execute 'drop function if exists '||o.nspname||'.'||o.proname||'('||o.arg_types||') cascade';
  end loop;
  -- 2.2. Удаление триггеров
  for o in (select trigger_schema, trigger_name from information_schema.triggers where trigger_schema = 'ora2pg_project')
  loop
    execute 'drop trigger if exists '||o.trigger_schema||'.'||o.trigger_name||' cascade';
  end loop;
  -- 2.3. Удаление внешних ключей
  for o in (select constraint_schema, constraint_name, table_name from information_schema.table_constraints where table_schema = 'ora2pg_project' and constraint_type = 'FOREIGN KEY')
  loop
    execute 'alter table if exists '||o.constraint_schema||'.'||o.table_name||' drop constraint if exists "'||o.constraint_name||'"';
  end loop;
  -- 2.4. Удаление всех оставшихся ограничений
  for o in (select constraint_schema, constraint_name, table_name from information_schema.table_constraints where table_schema = 'ora2pg_project')
  loop
    execute 'alter table if exists '||o.constraint_schema||'.'||o.table_name||' drop constraint if exists "'||o.constraint_name||'"';
  end loop;
  -- 2.5. Удаление индексов
  for o in (select schemaname, indexname from pg_indexes where schemaname = 'ora2pg_project')
  loop
    execute 'drop index if exists '||o.schemaname||'.'||o.indexname;
  end loop;
  -- 2.6. Удаление представлений
  for o in (select table_schema, table_name from information_schema.views where table_schema = 'ora2pg_project')
  loop
    execute 'drop view if exists '||o.table_schema||'.'||o.table_schema;
  end loop;
  -- 2.7. Удаление таблиц
  for o in (select table_schema, table_name from information_schema.tables where table_schema = 'ora2pg_project')
  loop
    execute 'drop table if exists '||o.table_schema||'.'||o.table_schema||' cascade';
  end loop;
  -- 2.8. Удаление последовательностей
  for o in (select sequence_schema, sequence_name from information_schema.sequences where sequence_schema = 'ora2pg_project')
  loop
    execute 'drop sequence if exists '||o.sequence_schema||'.'||o.sequence_name||' cascade';
  end loop;
  -- 2.9. Удаление доменов
  for o in (select domain_schema, domain_name from information_schema.domains where domain_schema = 'ora2pg_project')
  loop
    execute 'drop domain if exists '||o.domain_schema||'.'||o.domain_name||' cascade';
  end loop;
  -- 2.10. Удаление схемы ora2pg_project
  execute 'drop schema if exists ora2pg_project cascade';
  --------------------------------------------
  -- 3. Исключение сведений о приложении LUI4ORA2PG из LUI
  -- 3.1. Удаление пользователей приложения из групп
  delete from lui.lui_t_user_in_group where app_code = 'LUI4ORA2PG';
  -- 3.2. Удаление групп пользователей
  delete from lui.lui_t_usergroup where app_code = 'LUI4ORA2PG';
  -- 3.3. Удаление пользователей приложения из LUI и из БД
  for o in (select app_code, user_name from lui_t_user where app_code = 'LUI4ORA2PG')
  loop
    delete from lui_t_user where user_name = o.user_name and app_code = o.app_code;
    continue when o.user_name='ora2pg_project';
    execute 'drop user if exists '||o.user_name;
  end loop;
  -- 3.4. Удаление пользователя ora2pg_project из LUI и из БД
  delete from lui.lui_t_user_in_group where user_name = 'ora2pg_project';
  delete from lui.lui_t_user where user_name = 'ora2pg_project';
  
  -- 3.5. Удаление пользователя o2p_admin из БД
  execute 'drop user if exists o2p_admin';
  -- 3.6. Удаление сообщений об ошибках для приложения
  delete from lui.lui_t_message where app_code = 'LUI4ORA2PG';

  -- 3.7. Удаление заданий, созданных из приложения
  delete from lui.lui_t_task where app_code = 'LUI4ORA2PG';

  -- 3.8. Удаление прав на объекты приложения
  delete from lui.lui_t_object_right where app_code = 'LUI4ORA2PG';

  -- 3.9. Удаление типов объектов прав
  delete from lui.lui_t_object_type_right where app_code = 'LUI4ORA2PG';

  -- 3.10. Удаления форм пользовательского интерфейса
  delete from lui.lui_t_form_hold where app_code = 'LUI4ORA2PG';

  delete from lui.lui_t_form where app_code = 'LUI4ORA2PG';

  -- 3.11. Удаление описания соединений с БД для приложения
  delete from lui.lui_t_dtdbc where app_code = 'LUI4ORA2PG';

  -- 3.12. Удаление свойств приложения
  delete from lui.lui_t_application_property where app_code = 'LUI4ORA2PG';

  -- 3.13. Удаление приложения
  delete from lui.lui_t_application where code = 'LUI4ORA2PG';
  --------------------------------------------
end $remove_lui4ora2pg$;
commit;

drop tablespace if exists ora2pg_project;
drop owned by ora2pg_project cascade;
drop user if exists ora2pg_project;

